/************************************************************************/
/* Projekt : "lc1516a.dll" - biblioteka DLL WINDOWS dla karty LC-015-1612 */
/* Autor : Krzysztof Mroczek 1996                                        */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  <stdlib.h>
#include  "lc015.h"
#include  "lc015int.h"
#include  "px.h"

extern CModuleData *ModWsk[2]	;
extern Class1 *pPX ;
extern global GData				;

#define ADD_PGA_CNT 40

struct CModuleData *ModPtrAC;
/////////////////////////////////////////////////////////////////////////
// ANALOG_INPUT
//  Funkcja LC0_AnalogIn : sterowanie pomiarami a wykorzystaniem toru
//	  A/C karty . Jest zaimplementowany tryb pracy synchronicznej tzn.
//   sterowanie jest zwracane do wywoujcego programu po zakoczeniu pomiaru .
//   Po zainstalowaniu CTRL-BREAK pomiar mona przerwa w dowolnym momencie .
//   Tryby pracy :
//    - praca programowa : wyzwolenie pomiarw i odczyt wynikw programowo
//		- blokowo DMA : transmisja danych kanaem DMA : dziaa gdy Windows
//		  pracuje w trybie 'Enhanced' .
//	   - jednokoanalowo / wielokanalowo 1..n / praca ze zdefiniowan sekwencj
//															 pomiarow
//	   - pomiar po 1-ej prbce / caego bloku
//    - pomiar do bufora podanego przez uytkownika , bufora pamici rozszerzonej
//			DLL (ExtMem) lub z przepisaniem z pamici ExtMem do bufora uytkownika.
//    - praca z buforem cyklicznym lub jednorazowo
//    - praca w trybie pretriggering hardware'owey : zgodnie z dzialaniem
//      karty
//    - tryby pracy DMA :
//		  1. pojedynczy kanal 5 lub 6 : analogia do innych kart LC
//      2. 2 kanaly DMA , 5 i 6 , transmisje po 64K prbek : dlugie pomiary
//		  rwnie maksymalna szybko do 200 KHz czstotliwo prbkowania
//   Sprawdzanie parametrw przetwarzania odbywa si zgodnie z 'logik' i
//   definicj struktury 'lc0_analog_in'.
//   Algorytmy pomiarowe s zgodne z instukcj obsugi karty LC-015-1612 :
//	  cz dotyczca algorytmw programowania .
//  Parametry wejciowe :
//   param : daleki wskanik do struktury 'lc0_analog_in' z parametrami
//		wywoania i statusu .
/////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_AnalogIn(lc0_analog_in FAR *param)
{
 char errcode ;
 struct WaitForEndParam WEPAC;
 unsigned char mod ;
 BOOL single		 ;
 BOOL block			 ;
 BOOL syn			 ;
 BOOL longbuf	  	 ;
 BOOL shard        ;
 BOOL pretrig		 ;
 BOOL cycl			 ;
 BOOL seqmem		 ;
 int  DMAMode		 ;
 unsigned char chan ;
 unsigned long ll,lpret ;
 lc0_analog_in *par=NULL;
 unsigned long CTCLong ;
 unsigned int CTCWord1,CTCWord2 ,norm; //warto licznika do CTC0 i 1
 unsigned int umask[] = {0xfffe,0xfffd,0xfffb,0xfff7,0xffef,0xffdf,0xffbf,0xff7f,
								 0xfeff,0xfdff,0xfbff,0xf7ff,0xefff,0xdfff,0xbfff,0x7fff};

 register unsigned char  val;
 unsigned long inx=0;
 str1 pStr ;
 unsigned char err ;
 unsigned int il_s,il_s1,ii ;
 char  errex;
 unsigned char part[5] ,*ptr;
 unsigned long ptime ;
 unsigned int base ;
 register unsigned int samp ;
 unsigned char maxchan ;
 int far  *ptrfar;
 int huge *ptrhuge ;
 unsigned char *ptrmem,v5,v6;
 MSG mes ;

 param->LC0_ERR_STAT = LC0_E_OK	;
 param->LC0_STATUS = LC0_OK ;
 param->LC0_ARLEN = 0;
 param->LC0_ARMNUM =0;
 param->LC0_ARBUF =0;

 /*************************************************************************
	Sprawdzanie parametrw wywolania
 **************************************************************************/
 if((param->LC0_AMODULE >= LC0_MODA) && (param->LC0_AMODULE <= LC0_MODB))
  {
	errcode = ModWsk[(param->LC0_AMODULE) -1 ]->CheckApp();

	if(errcode != LC0_OK)
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }

  mod = param->LC0_AMODULE -1 ;

if(ModWsk[mod]->PAC.DevBusy)
 {
	param->LC0_STATUS = LC0_DEV_BUSY ;
	return ;
 }
 ModWsk[mod]->PAC.DevBusy=TRUE;

 if(ModWsk[mod]->InType==0)
  maxchan = AC_CHANNELS ;
 else
  maxchan = AC_CHANNELS / 2 ;
 //////////////////////////////////////////////////////////////////////
 if(((param->LC0_AMODE) & LC0_MOD_NEW_PAR)==0 )
  {
	 if(ModWsk[mod]->ACValid)
		par = &(ModWsk[mod]->ACParam) ;
	 else
	  {
		param->LC0_STATUS = LC0_NO_PARAMS ;ModWsk[mod]->PAC.DevBusy=FALSE;
		return ;
	  }
  }
 else
	par = param ;
 ModWsk[mod]->SetConvTime();
 ptrmem = (unsigned char *)MK_FP(param->LC0_AEMAR,param->LC0_ABMAR);
 if(((param->LC0_AMODE) & LC0_MOD_NEW_PAR)!=0)
  {
	if(par->LC0_ANUM == 0 || par->LC0_ANUM >AC_NUM )
	 {
	  param->LC0_STATUS = LC0_NONEX_DEV ;ModWsk[mod]->NormAC();
	  return ;
	 }
	if(((param->LC0_AMODE) & LC0_MOD_RAM_SEK)==0)
	 {
	  seqmem = 0;
	  if((par->LC0_ACHAN & 0x80)==0)
		{
		 if(par->LC0_ACHAN < 2 || par->LC0_ACHAN > maxchan)
		  {
			param->LC0_STATUS = LC0_BAD_CHAN_N ;
			ModWsk[mod]->NormAC();
			return ;
		  }
		 single = FALSE ;
		 chan = par->LC0_ACHAN ;
		}
	  else
		{
		 val= par->LC0_ACHAN & umask[7] ;
		 if(val == 0x00 || val > maxchan)
		  {
			param->LC0_STATUS = LC0_BAD_CHAN ;
			ModWsk[mod]->NormAC();
			return ;
		  }
		 single = TRUE ;
		 chan = val ;
		}
		ptrmem=NULL;
	 }
	else
	 {
	  seqmem = 1;
	  if(ptrmem==NULL)
		errcode=LC0_BAD_RAM_SEK	;
	  if(::IsBadReadPtr((unsigned char *)(ptrmem),2048))
		 errcode=LC0_BAD_RAM_SEK	;
	  if(errcode != LC0_OK)		{
		 param->LC0_STATUS = errcode ;
		 ModWsk[mod]->NormAC();
		 return ;
		}
	 }
	if((par->LC0_AMODE & 0xe080)!=0)
	 {
	  param->LC0_STATUS = LC0_BAD_MODE ;
	  ModWsk[mod]->NormAC();
	  return ;
	 }
	if((par->LC0_AMODE & LC0_MOD_SYNCHR)  ==0 )
	 syn = 0 ;
	else
	 syn = 1 ;
	if((par->LC0_AMODE & LC0_MOD_BLOCK)  ==0 )
	 block = 0 ;
	else
	 block = 1 ;
	ll = par->LC0_ASTOP.samples ;
	if((par->LC0_AMODE & LC0_MOD_CYCL)  ==0 )
	 {
	  pretrig = 0 ;
	  cycl =0 ;
	  lpret = 0;
	 }
	else
	 {
	  lpret = (unsigned long int)(par->LC0_APER2 / 2) ;
	  if((lpret==0)&&(block==1))
		{
		  param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		  ModWsk[mod]->NormAC();
		  return ;
		}
	  if(ll==0)
		{
		 cycl = 1;
		 pretrig = 0;
		}
	  else
		{
		 cycl = 0;
		 pretrig = 1 ;
		}
	  if(pretrig)
		{
		 if(ll+lpret >65536L)
		  {
			 param->LC0_STATUS = LC0_BAD_BUF_LEN ;
			 ModWsk[mod]->NormAC();
			 return ;
		  }
		}
	 }
	 if(block==0)
	  if((pretrig==1)||(cycl ==1))
		{
		 param->LC0_STATUS = LC0_BAD_MODE ;
		 ModWsk[mod]->NormAC();
		 return ;
		}
	if(ll+lpret>32768L)
	 longbuf = TRUE ;
	else
	longbuf = FALSE ;
	if(par->LC0_AMODE & LC0_MOD_EXT_MEM )
	 {
	  if(ModWsk[mod]->ExMem ==0 || ModWsk[mod]->ExSize ==0 || ModWsk[mod]->ptrex ==NULL )
		{
		 param->LC0_STATUS = LC0_NO_EXTMEM ;
		 ModWsk[mod]->NormAC();
		 return ;
		}
	  if((ModWsk[mod]->ExSize)/2 < ll+lpret)
		{
		 param->LC0_STATUS = LC0_BAD_BUF_LEN;
		 ModWsk[mod]->NormAC();
		 return ;
		}
	  errcode = 0;
	  if(longbuf)
		{
		 if(::IsBadHugeWritePtr((void huge *)(param->LC0_AMEMA),2*(ll+lpret)))
		  {
			errcode = 1;
		  }
		}
	  else
		{
		 if(::IsBadWritePtr((void far *)(param->LC0_AMEMA),2*((UINT)ll + (UINT)lpret)))
		  {
			errcode = 1;
		  }
		}
	  if(errcode !=0)
		{
		 param->LC0_STATUS = LC0_BAD_BUF_ADR;
		 ModWsk[mod]->NormAC();
		 return ;
		}
		if((par->LC0_AMODE & LC0_MOD_MEM_W) !=0)
		 {
		  if(param->LC0_ALEN == 0)
			param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		  if(param->LC0_ALEN > /*65536*/ 32768L)
			{
			 if(::IsBadHugeWritePtr((void huge *)(param->LC0_AADDR),2*(param->LC0_ALEN)))
			  {
				param->LC0_STATUS = LC0_BAD_BUF_ADR ;
			  }
			}
		  else
			{
			 if(::IsBadWritePtr((void far *)(param->LC0_AADDR),2*(UINT)(param->LC0_ALEN)))
			  {
				param->LC0_STATUS = LC0_BAD_BUF_ADR ;
			  }
			}
		  if(param->LC0_STATUS != LC0_OK)
			{
			 ModWsk[mod]->NormAC();
			 return ;
			}

		 }
	 }
	else
	 {
		if(param->LC0_ALEN == 0)
		 param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		if(param->LC0_ALEN < (ll+lpret))
		 param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		if(param->LC0_STATUS != LC0_OK)
		 {
		  ModWsk[mod]->NormAC();
		  return ;
		 }
		 if(param->LC0_ALEN > /*65536*/ 32768L)
		  {
			if(::IsBadHugeWritePtr((void huge *)(param->LC0_AADDR),2*(param->LC0_ALEN)))
			 {
			  param->LC0_STATUS = LC0_BAD_BUF_ADR ;
			 }
		  }
		 else
		  {
			if(::IsBadWritePtr((void far *)(param->LC0_AADDR),2*(UINT)(param->LC0_ALEN)))
			 {
			  param->LC0_STATUS = LC0_BAD_BUF_ADR ;
			 }
		  }
		 if(param->LC0_STATUS != LC0_OK)
		  {
			ModWsk[mod]->NormAC();
			return ;
		  }
	 }
	if((par->LC0_ASTST & 0xf0) != 0)
	 {
	  param->LC0_STATUS = LC0_ILL_STOP ;
	  ModWsk[mod]->NormAC();
	  return ;
	 }
  if(block)
	{
	 if(ModWsk[mod]->AC_DMA == 0xff)
	  {
		param->LC0_STATUS = LC0_NO_DMA ;
		ModWsk[mod]->NormAC();
		return ;
	  }
	 if(pretrig!=0)
	  {
		 if(ModWsk[mod]->AC_DMA2 == 0xff)
		  {
			param->LC0_STATUS = LC0_NO_DMA ;
			ModWsk[mod]->NormAC();
			return ;
		  }
		 if(((par->LC0_ASTST)& 0x0f)==1)
		  {
			param->LC0_STATUS = LC0_ILL_START ;
			ModWsk[mod]->NormAC();
			return ;
		  }
	  }
	 if(!syn)
	  {
		if(ModWsk[mod]->IRQ ==0xff)
		 {
		  param->LC0_STATUS = LC0_NO_IRQ ;
		  ModWsk[mod]->NormAC();
		  return ;
		 }
	  }
	 unsigned long omin ;
	 if((par->LC0_AMODE & LC0_MOD_EXT_CLK) ==0)
	  {
		if(seqmem==0)
		 {
		  if(single)
			omin = ModWsk[mod]->STable[0] ;
		  else
			omin = ModWsk[mod]->STable[chan -1];
		  if(par->LC0_APER < omin)
			{
			 param->LC0_STATUS = LC0_BAD_PER ;
			 ModWsk[mod]->NormAC();
			 return ;
			}
		 }
		CTCLong = (ModWsk[mod]->CLK * par->LC0_APER)/10 ;
		dividers(CTCLong,&CTCWord1,&CTCWord2);
		param->LC0_ARDIV1=CTCWord1;param->LC0_ARDIV2=CTCWord2;
	  }
	}
  else
	{
	 if(par->LC0_ASTST ==LC0_SHARD)
	  {
		param->LC0_STATUS = LC0_ILL_START ;
		ModWsk[mod]->NormAC();
		return ;
	  }
	 if((par->LC0_AMODE & LC0_MOD_EXT_CLK) != 0 )
	  {
		 param->LC0_STATUS = LC0_BAD_MODE ;
		 ModWsk[mod]->NormAC();
		 return ;
	  }
	}
	if(ModWsk[mod]->IsAsyncOpAC !=0)
	 {
	  param->LC0_STATUS = LC0_DEV_BUSY ;
	  ModWsk[mod]->NormAC();
	  return ;
	 }
	ModWsk[mod]->ACValid = TRUE ;
	ModWsk[mod]->ACParam = *par ;
	ModWsk[mod]->PAC.single=single ;
	ModWsk[mod]->PAC.block=block ;
	ModWsk[mod]->PAC.syn=syn ;
	ModWsk[mod]->PAC.longbuf=longbuf ;
	ModWsk[mod]->PAC.shard=shard ;
	ModWsk[mod]->PAC.chan=chan ;
	if((par->LC0_AMODE & LC0_MOD_EXT_CLK) ==0)
	 {
	  ModWsk[mod]->PAC.CTCLong=CTCLong ;
	  ModWsk[mod]->PAC.CTCWord1=CTCWord1 ;
	  ModWsk[mod]->PAC.CTCWord2=CTCWord2 ;
	 }
	ModWsk[mod]->PAC.PStop.samples=ll ;
	ModWsk[mod]->PAC.PStart=par->LC0_ASTART ;
	ModWsk[mod]->PAC.PStSt=par->LC0_ASTST ;
	ModWsk[mod]->PAC.Mode=par->LC0_AMODE ;
	ModWsk[mod]->PAC.seqmem = seqmem  ;
	ModWsk[mod]->PAC.pretrig = pretrig ;
	ModWsk[mod]->PAC.cycl = cycl ;
	ModWsk[mod]->PAC.lpret = lpret ;
  }
 else
  {
	single=ModWsk[mod]->PAC.single ;
	block=ModWsk[mod]->PAC.block ;
	syn=ModWsk[mod]->PAC.syn ;
	longbuf=ModWsk[mod]->PAC.longbuf ;
	shard=ModWsk[mod]->PAC.shard ;
	chan=ModWsk[mod]->PAC.chan ;
	CTCLong=ModWsk[mod]->PAC.CTCLong ;
	CTCWord1=ModWsk[mod]->PAC.CTCWord1 ;
	CTCWord2=ModWsk[mod]->PAC.CTCWord2 ;
	ll=ModWsk[mod]->PAC.PStop.samples ;
	par->LC0_ASTART=ModWsk[mod]->PAC.PStart ;
	par->LC0_ASTST =ModWsk[mod]->PAC.PStSt ;
	par->LC0_AMODE=ModWsk[mod]->PAC.Mode ;
	seqmem = ModWsk[mod]->PAC.seqmem  ;
	pretrig = ModWsk[mod]->PAC.pretrig  ;
	cycl = ModWsk[mod]->PAC.cycl  ;
	lpret = ModWsk[mod]->PAC.lpret ;
  }

 /**********************************************************************
	Cz sprztowa : szczegy algorytmy programowania karty
	LC-015-1612
 **********************************************************************/
 if(((param->LC0_AMODE) & LC0_MOD_START)!=0) //wystartowa
  {
	errcode = ModWsk[mod]->ProgMem(single , chan , ptrmem,block);
	if(errcode != LC0_OK)
	 {
	  param->LC0_STATUS = errcode ;
	  ModWsk[mod]->NormAC();
	  return ;
	 }
	 base = ModWsk[mod]->BaseAdr ;
	 if(par->LC0_AMODE & LC0_MOD_EXT_MEM)
		 {
		  ptrfar  = param->LC0_AMEMA ;
		  ptrhuge = (int huge *)(param->LC0_AMEMA) ;
		 }
	 else
		 {
		  ptrfar  = param->LC0_AADDR ;
		  ptrhuge = (int huge *)(param->LC0_AADDR) ;
		 }
	 if(par->LC0_ASTST !=LC0_SHARD)
	  {
		ptr = (unsigned char *)(&(par->LC0_ASTART));
		for(ii=0;ii<5;ii++)
		 part[ii]=*(ptr+ii);
		ptime = par->LC0_ASTART.time ;
		 shard = FALSE ;
	  }
	 else
	  shard = TRUE ;
	 if((ll==0)&&(cycl==0))
	  {
		ModWsk[mod]->PAC.DevBusy = FALSE;
		return ; //wyskok bez sygnalizacji
	  }
		 if(pretrig)
		  ModWsk[mod]->PAC.PGACnt +=ADD_PGA_CNT ;
	  outportb(base+CTC_0+3, 0xb2);//tryb 1
	  val = (unsigned char)(ModWsk[mod]->PAC.PGACnt & 0x00ff) ;
	  outportb(base+CTC_0+2,val);
	  val = (unsigned char)(ModWsk[mod]->PAC.PGACnt >> 8) ;
	  outportb(base+CTC_0+2,val);
	 if(block)
	  {
		if((par->LC0_AMODE & 0x1000) !=0)
		 WEPAC.page =1;
		else
		 WEPAC.page =0;
		if((pretrig!=0)||(cycl!=0))
		 DMAMode=2;
		else
		 {
		  if((ll <65536L) || (ModWsk[mod]->AC_DMA2==0xff))
			DMAMode=0 ;
		  else
			DMAMode = 1;
		 }
		 if((GData.WinFlags & WF_STANDARD) != 0)
		  {
			param->LC0_STATUS = LC0_NO_DMA_TRANS ;
			ModWsk[mod]->NormAC();
			return ;
		  }
		 pStr.par1 = 2*(ll+lpret) ;
		 if(!longbuf) // < 64 kB
		  {
			 pStr.par2 = FP_OFF(ptrfar);
			 pStr.par3 = FP_SEG(ptrfar);
		  }
		 else
		  {
			 pStr.par2 = FP_OFF(ptrhuge);
			 pStr.par3 = FP_SEG(ptrhuge);
		  }
		 pStr.par4 = 0; pStr.par5 = 0;
		 err = pPX->Fun6(&pStr,0);
		 switch(err)
		  {
			 case 0x04		:
			 case 0x06		:param->LC0_STATUS = LC0_NO_DMA_TRANS ;
								 break ;
			 case 0x05		:
								 param->LC0_STATUS = LC0_PREMATURE_END ;

								 break;
			 case 0x07		:if(par->LC0_AMODE & LC0_MOD_EXT_MEM)
									param->LC0_STATUS = LC0_BAD_EXTMEM ;
								 else
									param->LC0_STATUS = LC0_BAD_BUF_ADR ;
								 if(pStr.par4 != 0)
								  pPX->Fun7(&pStr,0);
								 break ;
		  };
		 if(param->LC0_STATUS !=LC0_OK )
		  {
			ModWsk[mod]->NormAC() ;
			return ;
		  }
		 err = pPX->Fun3(ModWsk[mod]->AC_DMA);
		 if((DMAMode!=0)&&(err==0))
		  {
			char exr;
			exr = pPX->Fun3(ModWsk[mod]->AC_DMA2);
			if(exr !=0)
			 {
			  pPX->Fun2(ModWsk[mod]->AC_DMA);
			  err = 1;
			 }
		  }
		 if(err!= 0)
		 {
		  param->LC0_STATUS = LC0_NO_DMA_TRANS ;
		  ModWsk[mod]->NormAC() ;
		  pPX->Fun7(&pStr,0);
		  return ;
		 }
		 unsigned char xll=1 ;
		 WEPAC.nst = 0;
		 if(pretrig)
		  {
			if(ll <= 65536L - lpret)
			 {
			  il_s1 = (unsigned int)(ll -1) ;
			  WEPAC.nst = 0;
			  WEPAC.est = il_s1;
			  xll = 0;
			 }
			else
			 {
				il_s1 = (unsigned int)(65536L - lpret -1)  ;
				ll = ll - 65536L - lpret ;
				WEPAC.nst = 1;
			 }
		  }
		 ldiv_t dx;
		 if(xll != 0)
		  {
			if(ll >65535L)
			 {
			  il_s = (unsigned int)65535 ;
			  dx=ldiv(ll,65536L);
			  WEPAC.nst+=(unsigned int)dx.quot;
			  WEPAC.est=(unsigned int)(ll-1 - (unsigned long)WEPAC.nst*65536L) ;
			  if(WEPAC.est==0xffff)
				{
				 v5 =0xff ;
				 v6 =0xff ;
				}
			  else
				{
				 v5 = (unsigned char)((WEPAC.est+2)& 0x00ff);
				 v6 = (unsigned char)((WEPAC.est+2)>> 8);;
				}
			 }
			else
			 {
			  il_s = (unsigned int)(ll -1);
			  WEPAC.nst += 0;
			  WEPAC.est = il_s;
			 }
		  }
		 WEPAC.modnum=mod;
		 WEPAC.st=0;
		 WEPAC.kanDMA = ModWsk[mod]->AC_DMA ;
		 WEPAC.kanDMA2 = ModWsk[mod]->AC_DMA2 ;
		 WEPAC.v3=(unsigned char)((WEPAC.est)& 0x00ff);
		 WEPAC.v4=(unsigned char)((WEPAC.est)>> 8);
		 WEPAC.base = ModWsk[mod]->BaseAdr ;
		 ModPtrAC=ModWsk[mod];
		 switch(WEPAC.kanDMA)
		  {
			case 5 :	WEPAC.LicznTransmisji = 0xc6 ;
						WEPAC.RejStrony = 0x8b;
						break ;
			case 6 :	WEPAC.LicznTransmisji = 0xca ;
						WEPAC.RejStrony = 0x89;
						break ;
			case 7 :	WEPAC.LicznTransmisji = 0xce ;
						WEPAC.RejStrony = 0x8a;
						break ;
		  };
		 switch(WEPAC.kanDMA2)
		  {
			case 5 :	WEPAC.LicznTransmisji2 = 0xc6 ;
						WEPAC.RejStrony2 = 0x8b;
						break ;
			case 6 :	WEPAC.LicznTransmisji2 = 0xca ;
						WEPAC.RejStrony2 = 0x89;
						break ;
			case 7 :	WEPAC.LicznTransmisji2 = 0xce ;
						WEPAC.RejStrony2 = 0x8a;
						break ;
		  };
		 if(par->LC0_ASTST !=LC0_SHARD)
		  {
			errcode = WaitForStart(par->LC0_ASTST ,part,ptime ,&errex,param->LC0_AMODULE,0);
			if(errcode!=LC0_OK)
			 {
			  param->LC0_STATUS = errcode ;
			  param ->LC0_ERR_STAT = errex ;
			  ModWsk[mod]->NormAC();
			  pPX->Fun7(&pStr,0);
			  pPX->Fun2(ModWsk[mod]->AC_DMA);
			  if(DMAMode!=0)
				pPX->Fun2(ModWsk[mod]->AC_DMA2);
			  return ;
			 }
		  }
		  ModWsk[mod]->ResetAC();
		 outportb(base+CTC_0+3,0x34); //CTC0 k0
		 outportb(base+CTC_0,(unsigned char)(CTCWord1 & 0x00ff));
		 outportb(base+CTC_0,(unsigned char)(CTCWord1 >> 8));
		 outportb(base+CTC_0+3,0x74); //CTC2 k1
		 outportb(base+CTC_0+1,(unsigned char)(CTCWord2 & 0x00ff));
		 outportb(base+CTC_0+1,(unsigned char)(CTCWord2 >> 8));
		 if(DMAMode==1)
		  {
			outportb(base+CTC_1+3,0x34);
			outportb(base+CTC_1,0 );
			outportb(base+CTC_1,0);
		  }
		 else
		  {
			if((DMAMode==2)&&(pretrig))
			 {
			  outportb(base+CTC_1+3,0x34);
			 }
		  }
		 ModWsk[mod]->ResetAC();
		 ModWsk[mod]->PSTSW |= _ENABLE_PRETRIG_ADC | _ENABLE_SAMPLE_IN |
		 _ENABLE_DMA_ADC | _ENABLE_IRQ ;
		 ModWsk[mod]->PSTSW &=umask[5];
		 ModWsk[mod]->PSTSW &=umask[4];
		 ModWsk[mod]->PSTSW &=umask[12];
		 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		 norm = ModWsk[mod]->PSTSW ;
		switch(DMAMode)
		 {
		  case 0 :
			 WEPAC.strona=ProgDMA16(WEPAC.kanDMA,1,0,0,il_s ,pStr.par5);
			 ModWsk[mod]->PSTSW |= _ENCHAN2 ;
			 break;
		  case 1 :
			 WEPAC.strona=ProgDMA16(WEPAC.kanDMA,1,0,0,il_s ,pStr.par5);
			 if(WEPAC.nst>1)
			  WEPAC.strona2=ProgDMA16(WEPAC.kanDMA2,1,0,0,il_s ,pStr.par5+131072L);
			 else
			  WEPAC.strona2=ProgDMA16(WEPAC.kanDMA2,1,0,0,WEPAC.est,pStr.par5+131072L);
			 break;
		  case 2 :
			 WEPAC.strona=ProgDMA16(WEPAC.kanDMA,1,1,0,(unsigned int)(lpret-1) ,pStr.par5);
			 if(pretrig!=0)
			  {
				WEPAC.strona2=ProgDMA16(WEPAC.kanDMA2,1,0,0,il_s1,pStr.par5+2L*lpret);
				ModWsk[mod]->PSTSW &= umask[6];
				ModWsk[mod]->PSTSW |=ENABLE_CHG_DMA_ADC ;
			  }
			 break ;
		 }
		if(syn)
		 {
		  if(DMAMode==1)
			ModWsk[mod]->PSTSW |= ENABLE_CHG_DMA_ADC ;
		  if((par->LC0_AMODE & LC0_MOD_EXT_CLK) ==0)
			ModWsk[mod]->PSTSW |=ENABLE_CTC_ADC ;
		  else
			ModWsk[mod]->PSTSW &=umask[3];
		  ModWsk[mod]->PSTSW &= umask[2];
		  unsigned long int LPRET = lpret ;
			errcode = WaitForEndAC( DMAMode,
											WEPAC.strona,
											WEPAC.strona2,
											WEPAC.nst,
											WEPAC.est,
											WEPAC.page,
											WEPAC.st,
											WEPAC.kanDMA,
											WEPAC.kanDMA2,
											WEPAC.LicznTransmisji,
											WEPAC.RejStrony,
											WEPAC.LicznTransmisji2,
											WEPAC.RejStrony2,
											WEPAC.v3,
											WEPAC.v4,
											v5,
											v6,
											WEPAC.base,
											shard,
											norm,
											cycl,
											&lpret,
											&(param->LC0_ARBUF),
										&(param->LC0_ARMNUM));
		  ModWsk[mod]->PSTSW = norm ;
		  outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		  ModWsk[mod]->ResetAC();
		  disableDMA16(ModWsk[mod]->AC_DMA);
		  if(DMAMode!=0)
			disableDMA16(ModWsk[mod]->AC_DMA2);
		  param->LC0_STATUS = errcode ;
		  if(param->LC0_ARMNUM > ll+LPRET)
			param->LC0_ARMNUM = ll+LPRET;
		  if(errcode == LC0_BROKEN)
			{
			 param ->LC0_ERR_STAT =LC0_E_BROKEN_RUN ;
			 ModWsk[mod]->MessageBreak();
			}
		  if((pStr.par4 !=0) && (param->LC0_ARMNUM !=0))
			{
			 pStr.par1 = 2*(param->LC0_ARMNUM ) ;
			 err = pPX->Fun9(&pStr,0);
			 if(err != 0)
			  {
				param->LC0_STATUS= LC0_PREMATURE_END ;
			  }
			 else
			  {
				if(pretrig)
				 {
				  for(unsigned int vvv=0 ; vvv<lpret;vvv++)
					{
					 if((*(ptrfar+vvv) & 0xf000)!=0)
					  {
						 param->LC0_ARBUF = (unsigned  int)vvv + 1 ;
						 break;
					  }
					}
				 }

			  }
			}
		 }
		else
		 {
		  param->LC0_STATUS = LC0_NOT_FULLY_SUP ; //
		  ModWsk[mod]->NormAC();
		  ModWsk[mod]->PSTSW = norm ;
		  outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		  ModWsk[mod]->ResetAC();
		  disableDMA16(ModWsk[mod]->AC_DMA);
		  if(DMAMode!=0)
			disableDMA16(ModWsk[mod]->AC_DMA2);
		 }
			pPX->Fun7(&pStr,0);
			pPX->Fun2(ModWsk[mod]->AC_DMA);
			if(DMAMode!=0)
			 pPX->Fun2(ModWsk[mod]->AC_DMA2);
	  }
	 else
	  {
		errcode = WaitForStart(par->LC0_ASTST ,part,ptime ,&errex,param->LC0_AMODULE,0);
		if(errcode!=LC0_OK)
		  {
			param->LC0_STATUS = errcode ;
			param ->LC0_ERR_STAT = errex ;
			ModWsk[mod]->NormAC();
			return ;
		  }
		 ModWsk[mod]->ResetAC();
		 ModWsk[mod]->PSTSW |=_ENABLE_PRETRIG_ADC | _ENABLE_SAMPLE_IN |
		 _ENABLE_DMA_ADC | _ENABLE_IRQ ;
		 ModWsk[mod]->PSTSW &= umask[5] ; ModWsk[mod]->PSTSW &= umask[4] ;
		 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		 unsigned int nn=0,step=0,im=0 ;
		 if(seqmem==0)
		  {
			 if(single)
			  step=1;
			 else
			  step=chan  ;
		  }
		 outport(base+SET_EN_ADC, 0);
		 while(1)
		  {
			nn=0;
			outport(base+ADC_ST_PR,0);
			do
			 {
				while ((inport(base+STATUS_READ) & 0x0001 ) == 0)
				 {
				  if(ModWsk[mod]->SynEnable)
					{
					 if(ModWsk[mod]->AsyncEnable==0)
					  {
						ModWsk[mod]->ResetAC();
						ModWsk[mod]->AsyncEnable=1;
						param->LC0_ERR_STAT = LC0_E_BROKEN_RUN ;
						param->LC0_STATUS = LC0_BROKEN ;
						break ;
					  }
					 if(IntBreak(&mes)==FALSE)
					  {
						ModWsk[mod]->ResetAC();
						ModWsk[mod]->MessageBreak();
						param->LC0_ERR_STAT = LC0_E_BROKEN_RUN ;
						param->LC0_STATUS = LC0_BROKEN ;
						break ;
					  }
					}
				  outport(base+ADC_ST_PR,0);
				 }
				if(param->LC0_STATUS != LC0_OK)
				 break;
				samp=inport(base + ADC_READ);
				if(longbuf)
				 *(ptrhuge+inx) = samp;
				else
				 *(ptrfar+(UINT)inx) = samp ;
				inx++;
				if(seqmem==1)
				 {
				  nn=1;
				  if((*(ptrmem+im) & 0x40) !=0)
					{
					 if((*(ptrmem+im) & 0x80) !=0)
					  im=0;
					 else
					  im++;
					 break ;
					}
				  else
					im++ ;
				 }
				else
				 nn++;
				if(ModWsk[mod]->SynEnable)
				 {
				  if(ModWsk[mod]->AsyncEnable==0)
					{
					 ModWsk[mod]->ResetAC();
					 ModWsk[mod]->AsyncEnable=1;
					 param->LC0_ERR_STAT = LC0_E_BROKEN_RUN ;
					 param->LC0_STATUS = LC0_BROKEN ;
					}
				  if(IntBreak(&mes)==FALSE)
					{
					 ModWsk[mod]->ResetAC();
					 ModWsk[mod]->MessageBreak();
					 param->LC0_ERR_STAT = LC0_E_BROKEN_RUN ;
					 param->LC0_STATUS = LC0_BROKEN ;
					}
				 }
				if((inx==ll)||(param->LC0_STATUS !=LC0_OK))
				 break ;
			 }
			while(nn!=step);
			if((inx==ll)||(param->LC0_STATUS!=LC0_OK))
			 break ;
		  }
		 ModWsk[mod]->ResetAC();
		 param->LC0_ARMNUM = inx ;
	  }
	 if((param->LC0_STATUS == LC0_OK)||(param->LC0_STATUS==LC0_BROKEN))
	  {
		if((par->LC0_AMODE & LC0_MOD_EXT_MEM) && (par->LC0_AMODE & LC0_MOD_MEM_W))
		 {
			unsigned long i ;
			for(i=0;i<param->LC0_ARMNUM;i++)
			 {
			  if(param->LC0_ARLEN >= param->LC0_ALEN)
				 {
				  param->LC0_STATUS = LC0_OTHER_LEN ;
				  break ;
				 }
				if(longbuf)
				 {
				  *(((int huge *)(param->LC0_AADDR))+i) = *(ptrhuge+i);
				 }
				else
				 {
					*(((int far *)(param->LC0_AADDR))+(UINT)i) = *(ptrfar+(UINT)i);
				 }
				param->LC0_ARLEN ++ ;
			 }
		 }
	  }
  }
  ModWsk[mod]->PAC.DevBusy=FALSE;
}



