/************************************************************************/
/* Projekt : "lc1516a.dll" - biblioteka DLL WINDOWS dla karty LC-015-1612 */
/* Autor : Krzysztof Mroczek 1996	                                          */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc015.h"
#include  "lc015int.h"
#include  "px.h"

#define CTC02P 1

extern CModuleData *ModWsk[4]	;
extern Class1 *pPX ;
extern global GData				;

struct CModuleData *ModPtrCA;
/////////////////////////////////////////////////////////////////////////
// ANALOG_OUT
// Funkcja LC0_AnalogOut :
//  Sterowanie torem C/A i konwersjami C/A moduu .
//  Jest zaimplementowana praca synchroniczna tzn. driver zwraca sterowanie
//  do wywolujcego go programu po zakoczeniu przetwarzania .
//  Po zainstalowaniu CTRL-BREAK przetwarzanie mona przerwa w dowolnym
//  momencie .
//  Analiza parametrw wywolanie jest realizowana zgodnie z 'logika'
//	 struktury 'lc0_analog_out' .
//  Algorytmu sprztowe s zgodne z instrukcj obsugi moduu LC-015-1612 :
//  cz dodtyczca algorytmw programowania .
//  Tryby pracy :
//   - praca programowa z programowymi sterowaniami
//   - praca blokowa z transferami DMA :
//		 1. transmisja pojedynczego bloku
//		 2. transmisja cykliczna : tryb CYCLE kontrolera DMA
//   - praca 1-o / wielokanalowa
//	  - pojedyncze lub wielokrotne sterowanie
//   - praca kanaem 16-o bitowym DMA
// Parametry wywoania :
//  param : daleki wskanik do struktury 'lc0_analog_out' z parametrami
//    wywoania i statusu .
/////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_AnalogOut(lc0_analog_out FAR *param)
{
 char errcode ;
 struct WaitForEndParam WEPCA;
 unsigned char mod ;
 BOOL single		 ;
 BOOL block			 ;
 BOOL syn			 ;
 BOOL longbuf		 ;
 BOOL shard        ;
 unsigned long ll,CTCLong  ;
 lc0_analog_out *par;
 unsigned int CTCWord1,CTCWord2 ;
 unsigned int umask[] = {0xfffe,0xfffd,0xfffb,0xfff7,0xffef,0xffdf,0xffbf,0xff7f,
								 0xfeff,0xfdff,0xfbff,0xf7ff,0xefff,0xdfff,0xbfff,0x7fff};
 int far  *ptrfar;
 int huge *ptrhuge ;
 char  errex;
 unsigned char part[5] ,*ptr;
 unsigned long ptime ;
 unsigned int base,samp,norm ;
 str1 pStr ;
 unsigned char err ;
 unsigned int il_s ,ii;

 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 param->LC0_NRMNUM = 0 ;

 /*********************************************************************
	Analiza parametrw wywoania
 **********************************************************************/
 if((param->LC0_NMODULE >= LC0_MODA) && (param->LC0_NMODULE <= LC0_MODB))
  {
	errcode = ModWsk[(param->LC0_NMODULE) -1 ]->CheckApp();
	if(errcode != LC0_OK) //jest bd
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }
  mod = param->LC0_NMODULE -1 ;
 if(ModWsk[mod]->PCA.DevBusy)
 {
	param->LC0_STATUS = LC0_DEV_BUSY ;
	return ;
 }
 ModWsk[mod]->PCA.DevBusy=TRUE;

 if(((param->LC0_NMODE) & LC0_MOD_NEW_PAR)==0 ) //stare
  {
	 if(ModWsk[mod]->CAValid)
	  {
		par = &(ModWsk[mod]->CAParam) ;
	  }
	 else
	  {
		param->LC0_STATUS = LC0_NO_PARAMS ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
  }
 else
  {
	par = param ;
  }

 if(((param->LC0_NMODE) & LC0_MOD_NEW_PAR)!=0)
 {
  if(par->LC0_NNUM == 0 || par->LC0_NNUM >ModWsk[mod]->CA_channels )
	{
	 param->LC0_STATUS = LC0_NONEX_DEV ;
	 ModWsk[mod]->NormCA();
	 return ;
	}
  if((par->LC0_NCHAN & 0x80)==0)
	{
	 if(par->LC0_NCHAN != 0x01 )
	  {
		param->LC0_STATUS = LC0_BAD_CHAN_N ;
		ModWsk[mod]->NormCA();
		return ;
	  }
	 single = FALSE ;
	}
  else
	{
	 if(par->LC0_NCHAN != 0x81 )
	  {
		param->LC0_STATUS = LC0_BAD_CHAN ;
		ModWsk[mod]->NormCA();
		return ;
	  }
	 single = TRUE ;
	}

  errcode = 0;
  if((par->LC0_NMODE & 0xe990)!=0)
	{
	  param->LC0_STATUS = LC0_BAD_MODE ;
	  ModWsk[mod]->NormCA();
	  return ;
	}
  if((par->LC0_NMODE & LC0_MOD_SYNCHR)!= 0)
	syn = TRUE ;
  else
	syn = FALSE ;
  if((par->LC0_NMODE & LC0_MOD_BLOCK) != 0)
	block = TRUE ;
  else
	block = FALSE ;
  ll = par->LC0_NSTOP.samples ;
  if(block)
	if(par->LC0_NSTOP.samples > 32768L)
	 longbuf = TRUE ;
	else
	 longbuf = FALSE ;
  if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
	{
	 if(ModWsk[mod]->ExMem ==0 || ModWsk[mod]->ExSize ==0 || ModWsk[mod]->ptrex ==NULL )
	  {
		param->LC0_STATUS = LC0_NO_EXTMEM ;
		ModWsk[mod]->NormCA() ;
		return ;
	  }
	 if((ModWsk[mod]->ExSize)/2 < ll)
	  {
		param->LC0_STATUS = LC0_BAD_BUF_LEN;
		ModWsk[mod]->NormCA();
		return ;
	  }
	 errcode = 0;
	 if(longbuf)
	  {
	  if(::IsBadHugeReadPtr((void huge *)(param->LC0_NADDR.extended_memory),2*ll))
		{
		 errcode = 1;
		}
	  }
	 else
	  {
		if(::IsBadReadPtr((void far *)(param->LC0_NADDR.extended_memory),2*(UINT)ll))
		 {
		  errcode = 1;
		 }
	  }
	 if(errcode !=0)
	  {
		param->LC0_STATUS = LC0_BAD_BUF_ADR;
		ModWsk[mod]->NormCA();
		return ;
	  }
	}
  else
	{
	 if(param->LC0_NLEN == 0)
	  {
		param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		ModWsk[mod]->NormCA();
		return ;
	  }
	 if(block)
	  {
		if(par->LC0_NLEN < par->LC0_NSTOP.samples)
		 {
		  param->LC0_STATUS = LC0_BAD_BUF_LEN ;
		  ModWsk[mod]->NormCA();
		  return ;
		 }
	  }
	 errcode = 0;
	 if(param->LC0_NLEN > 32768L)
	  {
	  //sprawdzany Windows - owo
	  if(::IsBadHugeReadPtr((void huge *)(param->LC0_NADDR.base_memory),2*(param->LC0_NLEN)))
		{
		 errcode = 1;
		}
	  }
	 else
	  {
	  if(::IsBadReadPtr((void far *)(param->LC0_NADDR.base_memory),2*(UINT)(param->LC0_NLEN)))
		{
		 errcode = 1;
		}
	  }
	 if(errcode !=0)
	  {
		param->LC0_STATUS = LC0_BAD_BUF_ADR ;
		ModWsk[mod]->NormCA();
		return ;
	  }
	}
  if((par->LC0_NSTST & 0xf0) != 0)
	{
	 param->LC0_STATUS = LC0_ILL_STOP ;
	 ModWsk[mod]->NormCA();
	 return ;
	}
  if(block)
  {
	 if(ModWsk[mod]->CA_DMA == 0xff)
	  {
		param->LC0_STATUS = LC0_NO_DMA ;
		ModWsk[mod]->NormCA();
		return ;
	  }
	 if((par->LC0_NMODE & LC0_MOD_CYCL) != 0)
	  {
		if(par->LC0_NSTOP.samples >65536L)
		 param->LC0_STATUS = LC0_BAD_BUF_LEN ;
	  }
	 if(param->LC0_STATUS == LC0_BAD_BUF_LEN)
	  {
		ModWsk[mod]->NormCA();
		return ;
	  }
	  if(single)
		{
		  if(par->LC0_NNUM == 2)
			{
			 param->LC0_STATUS = LC0_NO_DMA ;
			 ModWsk[mod]->NormCA();
			 return ;
			}
		}
	 unsigned long omin ;
	 if((par->LC0_NMODE & LC0_MOD_EXT_CLK) ==0)
	  {
		if(single)
		  omin = ModWsk[mod]->CA_Table[0];
		else
		  omin = ModWsk[mod]->CA_Table[1];
		if(par->LC0_NPER < omin )
		 {
		  param->LC0_STATUS = LC0_BAD_PER ;
		  ModWsk[mod]->NormCA();
		  return ;
		 }
		CTCLong = (ModWsk[mod]->CLK * par->LC0_NPER)/10 ;
		dividers(CTCLong,&CTCWord1,&CTCWord2);
	  }
  }
 else
  {
	if(par->LC0_NSTST ==LC0_SHARD)
	 {
	  param->LC0_STATUS = LC0_ILL_START ;
	  ModWsk[mod]->NormCA();
	  return ;
	 }
  }
 if(ModWsk[mod]->IsAsyncOpCA !=0)
  {
	param->LC0_STATUS = LC0_DEV_BUSY ;
	ModWsk[mod]->NormCA();
	return ;
  }
 if(block & !syn)
  {

  }

  ModWsk[mod]->CAValid = TRUE ;
  ModWsk[mod]->CAParam = *par ;
  //pozostae
  ModWsk[mod]->PCA.single=single ;
  ModWsk[mod]->PCA.block=block ;
  ModWsk[mod]->PCA.syn=syn ;
  ModWsk[mod]->PCA.shard=shard ;
  ModWsk[mod]->PCA.longbuf=longbuf ;
  if((par->LC0_NMODE & LC0_MOD_EXT_CLK) ==0)
	{
	 ModWsk[mod]->PCA.CTCWord1=CTCWord1 ;
	 ModWsk[mod]->PCA.CTCWord2=CTCWord2 ;
	 ModWsk[mod]->PCA.CTCLong=CTCLong ;
	}
  ModWsk[mod]->PCA.PStop.samples=ll ;
  ModWsk[mod]->PCA.PStart=par->LC0_NSTART ;
  ModWsk[mod]->PCA.PStSt=par->LC0_NSTST ;
  ModWsk[mod]->PCA.Mode=par->LC0_NMODE ;
 }
else
 {
  single=ModWsk[mod]->PCA.single ;
  block=ModWsk[mod]->PCA.block ;
  syn=ModWsk[mod]->PCA.syn ;
  shard=ModWsk[mod]->PCA.shard ;
  longbuf=ModWsk[mod]->PCA.longbuf ;
  CTCLong=ModWsk[mod]->PCA.CTCLong ;
  CTCWord1=ModWsk[mod]->PCA.CTCWord1 ;
  CTCWord2=ModWsk[mod]->PCA.CTCWord2 ;
  ll=ModWsk[mod]->PCA.PStop.samples ;
  par->LC0_NSTART=ModWsk[mod]->PCA.PStart ;
  par->LC0_NSTST =ModWsk[mod]->PCA.PStSt ;
  par->LC0_NMODE=ModWsk[mod]->PCA.Mode ;
 }

 if(param->LC0_NMODE & LC0_MOD_START)
  {
	if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
	 {
	  ptrfar  = param->LC0_NADDR.extended_memory ;
	  ptrhuge = (int huge *)(param->LC0_NADDR.extended_memory) ;
	 }
	else
	 {
	  ptrfar  = param->LC0_NADDR.base_memory ;
	  ptrhuge = (int huge *)(param->LC0_NADDR.base_memory) ;
	 }
	 if(par->LC0_NSTST !=LC0_SHARD) //inny ni sprztowy
	  {
		ptr = (unsigned char *)(&(par->LC0_NSTART));
		for(ii=0;ii<5;ii++)
		 part[ii]=*(ptr+ii);
		ptime = par->LC0_NSTART.time ;
		 shard =FALSE ;
	  }
	 else
	  shard = TRUE   ;
	 if(ll==0)
	  {
		ModWsk[mod]->CAValid = FALSE ;
		ModWsk[mod]->PCA.DevBusy=FALSE;
		return ;
	  }
	 base = ModWsk[mod]->BaseAdr ;
	 if(block)
	 {
		 if((GData.WinFlags & WF_STANDARD) != 0)
		  {
			param->LC0_STATUS = LC0_NO_DMA_TRANS ;
			ModWsk[mod]->CAValid = FALSE ;
			ModWsk[mod]->PCA.DevBusy=FALSE;
			return ;
		  }
		 pStr.par1 = 2*ll;
		 if(longbuf)
		  {
			 pStr.par2 = FP_OFF(ptrfar);
			 pStr.par3 = FP_SEG(ptrfar);
		  }
		 else
		  {
			 pStr.par2 = FP_OFF(ptrhuge);
			 pStr.par3 = FP_SEG(ptrhuge);
		  }
		 pStr.par4 = 0; pStr.par5 = 0;
		 err = pPX->Fun6(&pStr,1);//alokacja z kopiowaniem
		 switch(err)
		  {
			 case 0x04		:
			 case 0x06		:param->LC0_STATUS = LC0_NO_DMA_TRANS ;
								 break ;
			 case 0x05		:
								 param->LC0_STATUS = LC0_PREMATURE_END ;

								 break;
			 case 0x07		:if(par->LC0_NMODE & LC0_MOD_EXT_MEM)
									param->LC0_STATUS = LC0_BAD_EXTMEM ;
								 else
									param->LC0_STATUS = LC0_BAD_BUF_ADR ;
								 if(pStr.par4 != 0)
								  pPX->Fun7(&pStr,0);
								 break ;
		  };
		 if(param->LC0_STATUS !=LC0_OK )
		  {
			ModWsk[mod]->NormCA();
			return ;
		  }
		err = pPX->Fun3(ModWsk[mod]->CA_DMA);
		if(err!= 0)
		 {
		  param->LC0_STATUS = LC0_NO_DMA_TRANS ;
		  ModWsk[mod]->NormCA();
		  pPX->Fun7(&pStr,0);
		  return ;
		 }
		if(par->LC0_NSTOP.samples > 65536L)
		 {
		  il_s = (unsigned int)65535 ;
		  WEPCA.nst=(unsigned int)(ll/63536L) ;
		  WEPCA.est=(unsigned int)(ll - (unsigned long)WEPCA.nst*65536L) ;
		 }
		else
		 {
		  il_s = (unsigned int)(ll -1);
		  WEPCA.nst = 0;
		  WEPCA.est = il_s;
		 }
		WEPCA.modnum=mod;
		WEPCA.st=0;
		WEPCA.kanDMA = ModWsk[mod]->CA_DMA ;
		WEPCA.v3=(unsigned char)((WEPCA.est-1)& 0x00ff);
		WEPCA.v4=(unsigned char)((WEPCA.est-1)>> 8);
		WEPCA.base=ModWsk[mod]->BaseAdr ;
		ModPtrCA=ModWsk[mod];
		switch(WEPCA.kanDMA)
		 {
			case 5 :	WEPCA.LicznTransmisji = 0xc6 ;
						WEPCA.RejStrony = 0x8b;
						break ;
			case 6 :	WEPCA.LicznTransmisji = 0xca ;
						WEPCA.RejStrony = 0x89;
						break ;
			case 7 :	WEPCA.LicznTransmisji = 0xce ;
						WEPCA.RejStrony = 0x8a;
						break ;
		};
		WEPCA.cykl=0 ;
		if((par->LC0_NMODE & LC0_MOD_CYCL) != 0)
		 WEPCA.cykl=1 ;
		if(par->LC0_NSTST !=LC0_SHARD)
		 {
		  errcode = WaitForStart(par->LC0_NSTST ,part,ptime ,&errex,param->LC0_NMODULE,1);
		  if(errcode!=LC0_OK)
			{
			 param->LC0_STATUS = errcode ;
			 param ->LC0_ERR_STAT = errex ;
			 ModWsk[mod]->NormCA() ;
			 pPX->Fun7(&pStr,0);
			 pPX->Fun2(ModWsk[mod]->CA_DMA);
			 return ;
			}
		 }
		outportb(base+CTC_2+3,0x34);
		outportb(base+CTC_2,(unsigned char)(CTCWord1 & 0x00ff));
		outportb(base+CTC_2,(unsigned char)(CTCWord1 >> 8));
		outportb(base+CTC_2+3,0x74);
		outportb(base+CTC_2+1,(unsigned char)(CTCWord2 & 0x00ff));
		outportb(base+CTC_2+1,(unsigned char)(CTCWord2 >> 8));
		ModWsk[mod]->ResetCA();
		ModWsk[mod]->PSTSW |=_ENABLE_DMA_DAC | _ENABLE_CTRL_IN | _ENABLE_IRQ ;
		ModWsk[mod]->PSTSW &=umask[11] ;
		if(single)
		 ModWsk[mod]->PSTSW &=umask[8];
		else
		 ModWsk[mod]->PSTSW |=_DAC_SINGLE ;
		outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		norm = ModWsk[mod]->PSTSW ;
		WEPCA.strona=ProgDMA16(WEPCA.kanDMA,1,WEPCA.cykl,1,il_s ,pStr.par5);
	  if(syn)
		{
		 if((par->LC0_NMODE & LC0_MOD_EXT_CLK) ==0)
		  ModWsk[mod]->PSTSW |=ENABLE_CTC_DAC ;
		 else
			ModWsk[mod]->PSTSW &=umask[9];
		 ModWsk[mod]->PSTSW &= umask[10];
		 errcode = WaitForEndCA( 	WEPCA.strona,
											WEPCA.nst,
											WEPCA.est,
											WEPCA.st,
											WEPCA.kanDMA,
											WEPCA.LicznTransmisji,
											WEPCA.RejStrony,
											WEPCA.v3,
											WEPCA.v4,
											WEPCA.base,
											WEPCA.cykl,
											shard,
											norm,
										 &(param->LC0_NRMNUM));
		 ModWsk[mod]->PSTSW = norm ;
		 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		 ModWsk[mod]->ResetCA();
		 disableDMA16(ModWsk[mod]->CA_DMA);
		 pPX->Fun7(&pStr,0);
		 pPX->Fun2(ModWsk[mod]->CA_DMA);
		 param->LC0_STATUS = errcode ;
		 if(errcode == LC0_BROKEN)
		  {
			param ->LC0_ERR_STAT =LC0_E_BROKEN_RUN ;
			ModWsk[mod]->MessageBreak();
		  }
		}
	  else
		{
		 param->LC0_STATUS = LC0_NOT_FULLY_SUP ;
		 ModWsk[mod]->NormCA();
		 ModWsk[mod]->PSTSW = norm ;
		 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		 //zgaszenie ewentualnych przerwa + reset
		 ModWsk[mod]->ResetCA();
		 disableDMA16(ModWsk[mod]->CA_DMA);
		 pPX->Fun7(&pStr,0);
		 pPX->Fun2(ModWsk[mod]->CA_DMA);
		 return ;
		}
	 }
	 else
	  {
		errcode = WaitForStart(par->LC0_NSTST ,part,ptime ,&errex,param->LC0_NMODULE,1);
		if(errcode!=LC0_OK) //by bd
		 {
		  param->LC0_STATUS = errcode ;
		  param ->LC0_ERR_STAT = errex ;
		  ModWsk[mod]->NormCA() ;
		  return ;
		 }
		ModWsk[mod]->ResetCA(); // na wszelki wypadek
		ModWsk[mod]->PSTSW |=_ENABLE_DMA_DAC | _ENABLE_CTRL_IN | _ENABLE_IRQ ;
		ModWsk[mod]->PSTSW &=umask[11] ;
		// 1-2 DAC
		if(single)
		 ModWsk[mod]->PSTSW &=umask[8];
		else
		 ModWsk[mod]->PSTSW |=_DAC_SINGLE ;
		outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;
		norm = ModWsk[mod]->PSTSW ;
		samp = *(ptrhuge);
		int i;
		outport(base + SET_EN_DAC, 0);
		outportb(base + DAC_ST_PR, 0);
		for(i=0;i<100;i++)
		 i=i;
		if(single)
		{
		 if(par->LC0_NNUM == 1) //DAC1
		  outport(base+DAC_1_WRITE,samp);
		 else
		  outport(base+DAC_2_WRITE,samp);
		 param->LC0_NRMNUM = 1 ;
		}
	  else
		{
		 outport(base+DAC_1_WRITE,samp);
		 samp = *(ptrhuge+1);
		 outport(base+DAC_2_WRITE,samp);
		 param->LC0_NRMNUM = 2 ;
		}
		ModWsk[mod]->ResetCA();
	  }
  }
 ModWsk[mod]->PCA.DevBusy=FALSE;
}

