/************************************************************************/
/* Projekt : "lc1516a.dll" - biblioteka DLL WINDOWS dla karty LC-015-1612 */
/* Autor : Krzysztof Mroczek 1996                                        */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc015.h"
#include  "lc015int.h"
extern CModuleData *ModWsk[2]	;

///////////////////////////////////////////////////////////////////////////
// CTC_WRITE
// Funkcja LC0_CTCWrite :
//  Zapis bajtu programujcego CTC oraz wartoci pocztkowej do wybranego
//  kanau CTC programowanego przez uytkownika . Jest zaimplementowany
//  tryb pracy Read Back Mode , tylko dla ukadw 8254 , czyli
//  dla praktycznie wszystkich mozliwoci wstawianych ukadw do kart
//  LC-015-1612.
// UWAGA ! jest remapowanie "logiczne" numeracji kanaw , szczegy
// patrz instrukacja obsugi do biblioteki DLL .
// Parametry wejciowe :
//  param : daleki wskanik do struktury z parametrami eyeoania i
//  statusu .
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCWrite(lc0_ctc_write FAR *param)
{
	char errcode ;
	unsigned char p,val,val1,kan=0;
	unsigned int badr,adr1,adr2;
	unsigned char maska[]={0x01,0x02,0x04,0x08};

	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK;
	if((param->LC0_CMODULE >= LC0_MODA) && (param->LC0_CMODULE <= LC0_MODB))
	 {
		errcode = ModWsk[(param->LC0_CMODULE) -1 ]->CheckApp();
		if(errcode!=LC0_OK)
		 {
			param->LC0_STATUS = errcode;
			return;
		 }
		badr = ModWsk[(param->LC0_CMODULE) -1 ]->BaseAdr;
		if((param->LC0_CMODE & 0x03) == 0x00 )
		 {
		  param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  return;
		 }
		  p=param->LC0_CFUN & 0x0c ;
		  if(p==0x0c)
			param->LC0_STATUS = LC0_BAD_CTC_MODE ;
		  p=param->LC0_CFUN & 0xC0 ;
		  if(p==0xC0)
			{
			  p= (param->LC0_CFUN & 0x0e) >>1;
			  int cc=0;
			  for(int ii=0;ii<3;ii++)
				{
				  if((p & maska[ii])!=0)
					{
					 p = ii;
					 cc=1;
					 break;
					}
				}
			  if(cc==0) p =0;
			  switch(p)
				{
				 case 0 :adr1= badr+CTC_2+3;
							adr2 = badr+CTC_2+2 ;
							val = param->LC0_CFUN & 0xf1;
							val = val | 0x08;
							break;
				 case 1 :adr1= badr+CTC_1+3;
							adr2 = badr+CTC_1+1 ;
							val = param->LC0_CFUN ;
							break;
				 case 2 :adr1= badr+CTC_1+3;
							adr2 = badr+CTC_1+2 ;
							val = param->LC0_CFUN ;
							break;
				 default:adr1= badr+CTC_2+3;
							adr2 = badr+CTC_2+2 ;
							val = param->LC0_CFUN & 0xf1;
							val = val & 0x08;
							break;
				}
			  kan=p;
			  ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode[kan] = 1;
			}
		  else
			{
			 switch(p)
			  {
				case 0x00	:adr1= badr+CTC_2+3;
								 adr2 = badr+CTC_2+2 ;
								 val = (param->LC0_CFUN) | 0x80  ;
								 kan=0;
								 break;//CTC_2 k2
				case 0x40 	:adr1= badr+CTC_1+3;
								 adr2 = badr+CTC_1+1 ;
								 val = param->LC0_CFUN ;
								 kan=1;
								 break;
				case 0x80	:adr1= badr+CTC_1+3;
								 adr2 = badr+CTC_1+2 ;
								 val = param->LC0_CFUN ;
								 kan=2;
								 break;//CTC_1 k2 CTC_1 k1
			  }
			 ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode[kan] = 0;
			 p=param->LC0_CFUN & 0x30 ;
			 if(p==0)
			  param->LC0_STATUS = LC0_BAD_CTC_MODE ;
			 ModWsk[(param->LC0_CMODULE) -1 ]->RWCTCMode[kan] = p >> 4;
			}
		  if(param->LC0_STATUS != LC0_OK)
			return;
	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }
	 if((param->LC0_CMODE & 0x01)!=0 )
	  {
		outportb(adr1,val);
		if((param->LC0_CFUN & 0xC0) != 0xC0)
		 ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg[kan] = 1;
		else
		 ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg[kan] = 2;
	  }

	 if(((param->LC0_CMODE & 0x02)!=0 )&&
	 (ModWsk[(param->LC0_CMODULE) -1 ]->RBCTCMode[kan] == 0) )
	  {
		if(ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg[kan] ==0)
		 {
		  param->LC0_STATUS = LC0_CTC_NOT_PROGRAMMED ;
		  return ;
		 }
		val = (unsigned char)(param->LC0_CVAL & 0x00ff);
		outportb(adr2,val);
		if(ModWsk[(param->LC0_CMODULE) -1 ]->RWCTCMode[kan] == 3)
		 {
		  val1 = (unsigned char)(param->LC0_CVAL >> 8);
		  outportb(adr2,val1);
		 }

		ModWsk[(param->LC0_CMODULE) -1 ]->IsCTCProg[kan] = 2;
	  }
}


//////////////////////////////////////////////////////////////////////////
// CTC_READ
// Funkcja LC0_CTCRead :
// Odczyt wartoci wybranegi licznika CTC user'a oraz po uprezdnim
// zaprogramowaniu kanau w tryb Read Back Mode odczyt bajtu ststusu
// licznika .
// UWAGA ! jest remapowanie "logiczne" numeracji kanaw , szczegy
// patrz instrukacja obsugi do biblioteki DLL .
// Parametry wejciowe :
//  param : daleki wskanik do rekordu z parametrami wywoania i ststusu
//////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_CTCRead(lc0_ctc_read FAR *param)
{
 char errcode ;
 unsigned char val1,val2=0;
 unsigned int badr,adr1,adr2;

	param->LC0_ERR_STAT = LC0_E_OK		  ;
	param->LC0_STATUS = LC0_OK ;
	if((param->LC0_UMODULE >= LC0_MODA) && (param->LC0_UMODULE <= LC0_MODB))
	 {
		errcode= ModWsk[(param->LC0_UMODULE) -1 ]->CheckApp();
	 }
	else
	 {
		param->LC0_STATUS = LC0_NO_MODULE ;
		return ;
	 }
	if(errcode == LC0_OK)
	 {
	  badr = ModWsk[(param->LC0_UMODULE) -1 ]->BaseAdr;
	  if(param->LC0_UNUM >= CTC_NUM )
		{
		 param->LC0_STATUS = LC0_NONEX_DEV ;
		 return;
		}

	  switch(param->LC0_UNUM)
		{
		 case 0 :adr1 = badr+CTC_2+3;
					adr2 = badr+CTC_2+2;
					val1 = 0x80;
					break;
		 case 1 :adr1 = badr+CTC_1+3;
					adr2 = badr+CTC_1+1;
					val1 = 0x40;
					break;
		 case 2 :adr1 = badr+CTC_1+3;
					adr2 = badr+CTC_1+2;
					val1 = 0x80;
					break;
		}
	  if(ModWsk[(param->LC0_UMODULE) -1 ]->IsCTCProg[param->LC0_UNUM] != 2)
		 {
		  param->LC0_STATUS = LC0_CTC_NOT_PROGRAMMED ;
		  return ;
		 }

	  if(ModWsk[(param->LC0_UMODULE) -1 ]->RBCTCMode[param->LC0_UNUM] ==0)
		{
		 outportb(adr1,val1);
		}

	  val1 = inportb(adr2);

	  if(ModWsk[(param->LC0_UMODULE) -1 ]->RWCTCMode[param->LC0_UNUM] ==3)
		{
		  if(ModWsk[(param->LC0_UMODULE) -1 ]->RBCTCMode[param->LC0_UNUM] ==0)
			val2=inportb(adr2);
		  else
			val2 = 0;
		}
	  param->LC0_UVAL = val1 + (val2<<8);
	 }
	else
	 param->LC0_STATUS = errcode ;
}


