/************************************************************************/
/* Projekt : "lc1516a.dll" - biblioteka DLL WINDOWS dla karty LC-015-1612 */
/* Autor : Krzysztof Mroczek 1996	                                          */
/************************************************************************/
#define  STRICT
#include <windows.h>
#pragma hdrstop
#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc015.h"
#include  "lc015int.h"


extern CModuleData *ModWsk[2]	;

///////////////////////////////////////////////////////////////////////////
// DIGITAL_INPUT
// Funkcja LC0_DigitalIn :
//  Odczyt bajtu z wybranego portu cyfrowego karty :
//  Dziaaj parametry startu
// Parametry wejciowe :
//  param : daleki wskanik do struktury 'lc0_digital_in' z parametrami
//  wywoania i statusu .
///////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_DigitalIn(lc0_digital_in FAR *param)
{
 char errcode , errex;
 unsigned char par[5] ,*ptr;
 unsigned long ptime ;
 unsigned int val16,ii;

 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 if((param->LC0_DMODULE >= LC0_MODA) && (param->LC0_DMODULE <= LC0_MODB))
  {
	errcode = ModWsk[(param->LC0_DMODULE) -1 ]->CheckApp();
	if(errcode != LC0_OK)
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }
 if((param->LC0_DNUM == 0) || ((param->LC0_DNUM >DIN_NUM) ) )
  {
	 param->LC0_STATUS = LC0_NONEX_DEV ;
	 return ;
  }

 ptr = (unsigned char *)(&(param->LC0_DSTART));
 for(ii=0;ii<5;ii++)
  par[ii]=*(ptr+ii);
 ptime = param->LC0_DSTART.time ;
 errcode = WaitForStart(param->LC0_DSTST ,par,ptime ,&errex,param->LC0_DMODULE,1);
  if(errcode!=LC0_OK) //by bd
	{
	  param->LC0_STATUS = errcode ;
	  param ->LC0_ERR_STAT = errex ;
	  return ;
	}
  int pid ;
  pid = ModWsk[(param->LC0_DMODULE) - 1]->BaseAdr ;
  val16=inport(pid + DIG_IN_READ);
  if(param->LC0_DNUM == 1)
	 param->LC0_DVAL = (unsigned char)(val16 & 0x00ff) ;
  else
	 param->LC0_DVAL =  (unsigned char)(val16 >> 8);
}

////////////////////////////////////////////////////////////////////////////
// DIGITAL_OUTPUT
// Funkcja LC0_DigitalOut :
//  Zapis bajtu do wybranego portu cyfrowego moduu :
//  Diaaj parametry startu .
// Parametry wejciowe :
//  param : daleki wskanik do struktury 'lc0_digital_out' z parametrami
//  wywoania i statusu .
////////////////////////////////////////////////////////////////////////////
extern "C"  void FAR PASCAL _export LC0_DigitalOut(lc0_digital_out FAR *param)
{
 char errcode , errex;
 unsigned char par[4] ,*ptr;
 unsigned long ptime ;
 unsigned int val16,ii;

 param->LC0_ERR_STAT = LC0_E_OK		  ;
 param->LC0_STATUS = LC0_OK ;
 if((param->LC0_OMODULE >= LC0_MODA) && (param->LC0_OMODULE <= LC0_MODB))
  {
	errcode = ModWsk[(param->LC0_OMODULE) -1 ]->CheckApp();
	if(errcode != LC0_OK)
	 {
		param->LC0_STATUS = errcode ;
		return ;
	 }
  }
 else
  {
	param->LC0_STATUS = LC0_NO_MODULE ;
	return ;
  }
 if((param->LC0_ONUM == 0) || (param->LC0_ONUM >DOUT_NUM) )
  {
	 param->LC0_STATUS = LC0_NONEX_DEV ;
	 return ;
  }
 ptr = (unsigned char *)(&(param->LC0_OSTART));
 for(ii=0;ii<5;ii++)
  par[ii]=*(ptr+ii);
 ptime = param->LC0_OSTART.time ;
 errcode = WaitForStart(param->LC0_OSTST ,par,ptime ,&errex,param->LC0_OMODULE,1);
 if(errcode!=LC0_OK)
	{
	  param->LC0_STATUS = errcode ;
	  param ->LC0_ERR_STAT = errex ;
	  return ;
	}
  // zapis portu
  int pid , oval;
  pid = ModWsk[(param->LC0_OMODULE) - 1]->BaseAdr ;
  oval = param->LC0_OVAL ;
 if(param->LC0_ONUM==1)
	{
	 val16 = (unsigned int)oval;
	 ModWsk[(param->LC0_OMODULE) - 1]->PDIGW &=0xff00;
	 ModWsk[(param->LC0_OMODULE) - 1]->PDIGW |=val16;
	}
  else
	{
	 val16 = (unsigned int)oval<<8;
	 ModWsk[(param->LC0_OMODULE) - 1]->PDIGW &=0x00ff;
	 ModWsk[(param->LC0_OMODULE) - 1]->PDIGW |=val16;
	}
 outport(pid+DIG_OUT_WRITE,ModWsk[(param->LC0_OMODULE) - 1]->PDIGW);
}

