/************************************************************************/
/* Projekt : "lc1516a.dll" - biblioteka DLL WINDOWS dla karty LC-015-1612 */
/* Plik implementacyjny biblioteki DLL dla karty AMBEX LC-015-1612		*/
/* Typ : Windows 16																		*/
/* Autor : Krzysztof Mroczek 1996                                       */
/************************************************************************/
#define  STRICT
#include <windows.h>
//#include <alloc.h>
#pragma hdrstop

#define _EXPORT _export
#include  <toolhelp.h>
#include  <dos.h>
#include  "lc015.h"
#include  "lc015int.h"
#include	 "px.h"

CModuleData *ModWsk[2]	;
Class1 *pPX ;
global GData				;

// parametry LibMain()
 HINSTANCE	DLLInst			; // parametr wywoania LibMain
 WORD			DLLDseg			; // ~
 WORD       DLLHeap			; // ~


/******************************************************************/
/*******************************************************************
 Funkcja LibMain : inicjacja biblioteki DLL oraz zmiennych programu
  i wczytanie parametrow z pliku konfiguracyjnego .
 Parametry wejciowe :
	hInstance : deskryptor biblioteki DLL
	wDataSegment : nie uywane
	wHeapSize : nie uywane
	lpszCmdLine : nie uzywane .
 Rezultat :
  1 - bez bdu
  0 - by bd
*******************************************************************/
#pragma argsused
#if defined(__FLAT__)
BOOL WINAPI DllEntryPoint( HINSTANCE hinstDll,
									DWORD fdwRreason,
									LPVOID plvReserved)
#else
int FAR PASCAL LibMain( HINSTANCE hInstance,
								WORD wDataSegment,
								WORD wHeapSize,
								LPSTR lpszCmdLine )
#endif
{
#ifndef  __FLAT__

// The startup code for the DLL initializes the local heap(if there is one)
// with a call to LocalInit which locks the data segment.

	 if ( wHeapSize != 0 )
		  UnlockData( 0 );
#endif
	DLLInst = hInstance ;
	DLLDseg = wDataSegment ;
	DLLHeap = wHeapSize ;
	GData.modules = 0;
	GData.globalinit = FALSE ;
	GData.WinFlags = GetWinFlags();
	ModWsk[0] = new CModuleData(BASEA);
	ModWsk[1] = new CModuleData(BASEB);
	if((ModWsk[0]==NULL)||(ModWsk[1]==NULL))
	 {
		//bd fatalny
		return 0 ;
	 }
	LoadParameters();
	pPX		 = new Class1();
	if((pPX == NULL) || (pPX->Var1==FALSE) ||
	(((GData.WinFlags & WF_WIN386 )!= 0)&& (pPX->Var3 == 0) ))
	 {
	  GData.DMAError=LC0_NOT_INIT ;
	 }
	 else
	  GData.DMAError=LC0_OK ;

	GData.DMAAdress = 0;
	if(GData.DMAError!=LC0_OK)
	 {
	  //kontrolka
	  ::MessageBeep(-1);
	  return 0 ;
	 }
	return 1;
}

#pragma argsused
/*************************************************************************
  Funkcja WEP :
	Zakonczenie pracy biblioteki DLL .
  Parametry wejciowe :
	bSystemExit : nie uywane
  Rezultat :
	1 - OK.
*************************************************************************/
int FAR PASCAL WEP ( int bSystemExit )
{
	 return 1;
}
