 /* ****************************************************************** */
/* Projekt : biblioteka DLL "lc1516a.dll" dla karty LC-015-1612			 */
/* s****************************************************************** */
/* Plik implementacyjny wewntrzny LC1516A.dll								 */
/* Header  : "lc015int.h"															 */
/* Autor : Krzysztof Mroczek  , 1996/97                               */
/**********************************************************************/
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <dos.h>
#include <dir.h>
#include <time.h>
#include "lc015.h"
#include "lc015int.h"

extern CModuleData *ModWsk[2]	; //tablica wskaza do obiektw moduw A,B
extern global GData					; //globalne dane o moduach
extern HINSTANCE	DLLInst			; // parametr wywoania LibMain
extern WORD		DLLDseg				; // ~
extern WORD      DLLHeap			; // ~

extern struct CModuleData *ModPtrAC;
extern struct CModuleData *ModPtrCA;
/////////////////////////////////////////////////////////////////////
 unsigned char maska[]={1,2,4,8,16,32,64,128};
 #define INIKEYGLOB	 3			/* ilo parametrw globalnych w pliku .INI */
 #define INITKEYMOD	 14		/* ilo parametrw dot. moduw w pliku .INI*/
 char config_file[MAXPATH];		/* plik konfiguracyjny */
 char ini_file[]="AMBEX.INI";
 char *SectionTerm = "[LC-";            /* nagwek sekcji dla nowej karty*/
 //////////////////////////////////////////////////////////////////////////
 // nazwy poszczeglnych parametrw z pliku AMBEX.ini
 ///////////////////////////////////////////////////////////////////////////

 char *IniKeyGlob[] =   {
								"PATH",
								"INTTIME",
								"MODULES"
							  };   // STRINGI GLOBALNE DLA LC-015-1612
 char *IniKeyMod[]	 = {
							 "AD_CONVERTER",
							 "AD_CONVTIME",
							 "AD_CONVTABLE",
							 "PGATYPE",
							 "EXTMEMBUFFER",
							 "MODE",
							 "CLKFREQUENCY",
							 "IRQNUMBER",
							 "DA_CHANNELS",
							 "AD_INTYPE",
							 "AD_VMIN",
							 "AD_VMAX",
							 "AD_DMANUMBER",
							 "DA1_VMIN",
							 "DA1_VMAX",
							 "DA2_VMIN",
							 "DA2_VMAX",
							 "DA_DMANUMBER",
							 "DA_CONVTABLE",
							};  //STRINGI MODUOWE DLA LC-015-1612
char *PGAType[]= {
						"NONE" ,
						"PGA202",
						"PGA203",
						};
char *InType[] = {
						"UNI",
						"BIP",
					  };
// 18.03.1996
//ADType  0-ADS574 ,1-AD1674,2-ADS774 ,3-AD678
char *ADSType[] = {
						 "ADS574",
						 "AD1674",
						 "ADS774",
						 "AD678",
						};
///////////////////////////////////////////////////////////////////////////
// implementacja klasy zarzdzajacej poszczeglnymi moduami
///////////////////////////////////////////////////////////////////////////
/*
 Konstruktor
 Parametry wejciowe :
  BaseAdres - adres bazowy urzdzenia
*/
CModuleData::CModuleData(unsigned int BaseAdres)
 {
	IsInit	= FALSE					;
	IsLoaded = FALSE					;
	InitError = LC0_OK;
	IsIRQProc = FALSE	;
	IsAsyncOpAC	 = 0					;
	IsAsyncOpCA = 0 ;
	AsyncEnable = 1					;
	SynEnable	 = 0					;
	BreakProc = NULL					;
	ACValid = FALSE					;
	CAValid = FALSE					;
	BaseAdr	= BaseAdres				;
	PSTSW		= 0xc7ce					;
	PDIGW		= 0xffff					;
	hexmem = NULL ; ptrex = NULL;
	ExSize = 0;
	InExSize = 0 ;
	PAC.DevBusy = FALSE ;
	PCA.DevBusy = FALSE ;
	for(int i=0;i<3;i++)
	 {
	  IsCTCProg[i] =0;
	  RWCTCMode[i] = 3;
	 }
	PAC.CTCLong= 0x10101010L;
	PAC.CTCWord1=0x1010;
	PAC.CTCWord2=0x1010;
	PAC.PGACnt=250 ;
	PCA.CTCLong= 0x10101010L;
	PCA.CTCWord1=0x1010;
	PCA.CTCWord2=0x1010;
	IsConvtable=0;
	VPGA=1;
	AC_DMA2 = 0xff;
 }

//////////////////////////////////////////////////////////////////////
// Metoda ->Exit()
// czyszczenie strujtury danych z informacjami o module
//////////////////////////////////////////////////////////////////////
void::CModuleData::Exit()
 {
	IsInit = FALSE ;
	IsAsyncOpAC = 0					;
	IsAsyncOpCA = 0					;
	AsyncEnable = 1					;
	SynEnable	 = 0					;
	BreakProc = NULL					;
	ACValid =FALSE;
	CAValid = FALSE;
	hexmem = NULL ; ptrex = NULL;
	ExSize = 0;
	IsIRQProc = FALSE ;
 }

//////////////////////////////////////////////////////////////////////
// destruktor
//////////////////////////////////////////////////////////////////////
CModuleData::~CModuleData()
 {
	IsLoaded = FALSE		;
	InitError=LC0_OK;
	Exit();
 }

//////////////////////////////////////////////////////////////////////
// Metoda ->CheckApp()
//sprawdzenie statusu zadania odwoujcego si do moduu
// rezultat : kod bdu lub LC0_OK
//////////////////////////////////////////////////////////////////////
int CModuleData::CheckApp()
 {
	HTASK		 hTask ;
	if(InitError==LC0_BAD_CONFIG)
	 return(LC0_BAD_CONFIG);
	if(!IsLoaded)
	 return(LC0_NO_MODULE);
	if(!IsInit)
	 return LC0_NOT_INIT ;
	hTask = ::GetCurrentTask();
	if(hTask != AppTask)
	  return	LC0_REJECTED ;
	return LC0_OK ;
 }

///////////////////////////////////////////////////////////////////
// Metoda ->CheckModule()
// sprawdza czy rzeczywiscie jest zainstalowany modu
// poprzez badanie istnienia kanau CTC kanal 0
// rezultat : kod bedu lub LC0_OK
///////////////////////////////////////////////////////////////////
char CModuleData::CheckModule()
{
 char err = LC0_OK ;
  return(err);
}

//////////////////////////////////////////////////////////////////////
// Metoda ->ResetAC()
//reset sprztowy karty : czc A/C
//////////////////////////////////////////////////////////////////////
void CModuleData::ResetAC() //resetuje kart
  {
	 PSTSW |= 0x4001 ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;

	 PSTSW &= 0xbffe ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;

	 PSTSW |= 0x4001 ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;
  }

//////////////////////////////////////////////////////////////////////
// Metoda ->ResetCA()
//reset sprztowy karty : czc C/A
//////////////////////////////////////////////////////////////////////
 void CModuleData::ResetCA()
  {
	 PSTSW |= 0x8001 ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;

	 PSTSW &= 0x7ffe ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;

	 PSTSW |= 0x8001 ;
	 outport(BaseAdr + STATUS_WRITE , PSTSW) ;
  }

///////////////////////////////////////////////////////////////////////
// Metoda ->ClearCard()
// inicjacja pocztkowa karty przy MODULE_INIT - reset
////////////////////////////////////////////////////////////////////////
void CModuleData::ClearCard()
{

 PSTSW		= 0xc7ce	;
 if(InType!=0) //BIP
	PSTSW	  &= 0xff7f ;
 ResetAC();
 ResetCA();
 PSTSW |=0x0001;
 outport(BaseAdr + STATUS_WRITE , PSTSW) ;
 CTCInitWrite();
 ResetAC();
 ResetCA();
}

////////////////////////////////////////////////////////////////////////
// Metoda ->ClearDACs()
// Wyzerowanie portw analogowych C/A
////////////////////////////////////////////////////////////////////////
void CModuleData::ClearDACs()
{
 ResetCA();
 if(CA_channels==1)
  {
	PSTSW &=0xfeff;
	outport(BaseAdr + STATUS_WRITE , PSTSW) ;
	outport(BaseAdr + SET_EN_DAC, 0);
	outportb(BaseAdr + DAC_ST_PR, 0);
	if(CA1_V1 >=0)
	 {
	  outport(BaseAdr+DAC_1_WRITE,0x0000);
	 }
	else
	 {
	  outport(BaseAdr+DAC_1_WRITE,0x0800);
	 }
  }

 if(CA_channels==2)
  {
	PSTSW |= 0x0100 ;
	outport(BaseAdr + STATUS_WRITE , PSTSW) ;
	outport(BaseAdr + SET_EN_DAC, 0);
	outportb(BaseAdr + DAC_ST_PR, 0);
	if(CA1_V1 >=0)
	 {
	  outport(BaseAdr+DAC_1_WRITE,0x0000);
	 }
	else
	 {
	  outport(BaseAdr+DAC_1_WRITE,0x0800);
	 }
	if(CA2_V1 >=0)
	 {
	  outport(BaseAdr+DAC_2_WRITE,0x0000);
	 }
	else
	 {
	  outport(BaseAdr+DAC_2_WRITE,0x0800);
	 }
  }
 ResetCA();
}

///////////////////////////////////////////////////////////////////////
// Metoda ->ResetCTC()
// ustawienie CTC w przypadku pracy wielokanaowej
///////////////////////////////////////////////////////////////////////
void CModuleData::ResetCTC()
{

}

//////////////////////////////////////////////////////////////////////
// Metoda ->MessageBreak()
// wywoanie funkcji obsugi BREAK
//////////////////////////////////////////////////////////////////////
void CModuleData::MessageBreak()
 {
	HWND hwnd;
	if(BreakProc==NULL)
	 {
	  ::MessageBeep(-1);
	  hwnd = ::GetActiveWindow();
	  ::MessageBox(hwnd,"LC1516A.DLL message box : LC0_BREAK_EXEC","LC-015-1612 Info",MB_OK);
	 }
	else
	 (*BreakProc)();
 }

//////////////////////////////////////////////////////////////////////
// Metoda ->CTCInitWrite()
// programowanie CTC karty
/////////////////////////////////////////////////////////////////////
void CModuleData::CTCInitWrite()
{

 outportb(BaseAdr+3+CTC_0,0x34);
 outportb(BaseAdr+CTC_0,0x10);
 outportb(BaseAdr+CTC_0,0x10);
 outportb(BaseAdr+3+CTC_0,0x74);
 outportb(BaseAdr+CTC_0+1,0x10);
 outportb(BaseAdr+CTC_0+1,0x10);

 outportb(BaseAdr+3+CTC_0,0xba);
 outportb(BaseAdr+CTC_0+2,250);
 outportb(BaseAdr+CTC_0+2,0);
 outportb(BaseAdr+3+CTC_1,0x34);
 outportb(BaseAdr+CTC_1,0xff);
 outportb(BaseAdr+CTC_1,0xff);

 outportb(BaseAdr+3+CTC_2,0x34);
 outportb(BaseAdr+CTC_2,0x10);
 outportb(BaseAdr+CTC_2,0x10);
 outportb(BaseAdr+3+CTC_2,0x74);
 outportb(BaseAdr+CTC_2+1,0x10);
 outportb(BaseAdr+CTC_2+1,0x10);

}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->SetConvTime()
// ustawienie parametru PAC.PGACnt
// koniecznie dobrze poda czas konwersji przetwornika Tconv[ns] :
///////////////////////////////////////////////////////////////////////////////
void CModuleData::SetConvTime()
{
 unsigned int val1, val2 ;
 val1 = Tconv / 100 ;
 val2 = 100 ;
  if((VPGA == 4)&&(PGA==1))
	{
	 if(val1>val2)
	  PAC.PGACnt = val1 ;
	 else
	  PAC.PGACnt = val2 ;
	}
  else
	PAC.PGACnt = val1 ;
}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->MemoryTest()
// Test wewntrznej pamici sekwencji
// Rezultat :
//  kod bdu lub LC0-OK
///////////////////////////////////////////////////////////////////////////////
char CModuleData::MemoryTest()
{
 int i,j=1;
 unsigned char val=0,valr;
 char err=LC0_OK;
 ResetAC();
 ResetCA();
 CTCInitWrite();
 ResetAC();
 ResetCA();
 for(i = 0; i <2048 ; i++)
  {
	if(i==j*256)
	 {
		j++;
		val=0;
	 }
	else
	 val++;
	outportb(BaseAdr + RAM_WRITE,val );
  }
 ResetAC();
 val=0;
 j=1;
 for(i = 0; i <2048 ; i++)
  {
	if(i==j*256)
	 {
		j++;
		val=0;
	 }
	else
	 val++;

	valr=inportb(BaseAdr + RAM_READ);
	if(val!=valr)
	 {
	  err=LC0_NO_MODULE;
	  break;
	 }
  }
 ResetAC();
 for(i = 0; i <2048 ; i++)
  {
	 outportb(BaseAdr + RAM_WRITE,0xc0);
  }
 ResetAC();
 ResetCA();
 return err;
}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->ProgMem()
// Programowanie pamici sekwencji pomiarowej
// Uytkownik sam musi poprawnie wypeni struktur pamici (wzmocnienie te)!!!
// Jest sprawdzenia poprawnoci okresu prbkowania oraz
// przekroczenie zakresu 2048 b .
// Zwraca LC0_BAD_PER , gdy z sekwencji wynika za may okres prbkowania
// Parametry wejciowe :
//  single : praca 1-o kanalowa/wielokanalowa
//  chan   : ilosc kanalow / numer kanalu
//  ptr    : wskanik do tablicy progr. pamici
//  block  : ytub blokowy/programowy
////////////////////////////////////////////////////////////////////////////////
char CModuleData::ProgMem(BOOL single , unsigned char chan , unsigned char *ptr,
BOOL block)
{
 unsigned char err=LC0_OK,val;
 unsigned int n=0,i;
 ResetAC();
 if(ptr==NULL)
  {
	 if(single)
	  outportb(BaseAdr + RAM_WRITE,chan-1+0xc0+16*(VPGA-1));
	 else
	  {
		 for(i=0;i<chan;i++)
		  {
			if(i==chan-1)
			 outportb(BaseAdr + RAM_WRITE,i+0xc0+16*(VPGA-1));
			else
			 outportb(BaseAdr + RAM_WRITE,i/*+0x40*/+16*(VPGA-1));
		  }
	  }
  }
 else
  {
	 for(i=0;i<2048;i++)
	  {
		val=*(ptr+i);
		if(i==2047)
		 val |= 0xc0 ;
		if((val & 0xC0)==0x80) 
		 val |=0x40;
		n++;
		if(block==TRUE)
		 {
		  if(PAC.CTCLong <(unsigned long)n * (unsigned long)PAC.PGACnt)
			err=LC0_BAD_RAM_SEK	 ; //bdna sekwencja pomiarowa
		 }
		if((val & 0x40)!=0) //gdy koniec sekwencji
		 n=0;
		outportb(BaseAdr + RAM_WRITE,val);
		if((val & 0xc0)==0xc0) //koniec pieni
		 break ;
	  }
  }
 ResetAC();
 return err;
}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->NormAC()
// normalizacja A/C
///////////////////////////////////////////////////////////////////////////////
void CModuleData::NormAC()
{
 ACValid = FALSE ;
 PAC.DevBusy=FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->NormCA()
// normalizacja C/A
///////////////////////////////////////////////////////////////////////////////
void CModuleData::NormCA()
{
 CAValid = FALSE ; //flaga wanoci parametrw
 PCA.DevBusy=FALSE;
}

///////////////////////////////////////////////////////////////////////////////
// Metoda ->AllocExtMem()
// Alokacja bufora pamici rozszerzonej EXTMEM DLL dla aplikacji
// Rezultat :
// LC0_OK lub kod bdu
///////////////////////////////////////////////////////////////////////////////
char CModuleData::AllocExtMem()
{
  BOOL er=FALSE;

  if(ExMem != 0) //jest yczenie
	{
	 hexmem = ::GlobalAlloc(GMEM_MOVEABLE|GMEM_NODISCARD|GMEM_NOCOMPACT|
	 GMEM_LOWER,InExSize);
	 if(hexmem!=NULL)
	  {
		ptrex = (int huge *)(::GlobalLock(hexmem));
		if(ptrex==NULL)
		 er=TRUE;
	  }
	 else
	  {
		er=TRUE;
	  }

	 if(er)
		{
		 hexmem = NULL ; ptrex = NULL;
		 ExSize = 0;
		}
	 else
	  ExSize = InExSize ;
	}
  else
	{
	 hexmem = NULL ; ptrex = NULL;ExSize = 0;
	}
  return LC0_OK ;
}

/////////////////////////////////////////////////////////////////////////
// Metoda ->FreeExtMem()
// Zwolnienie bufora pamici rozszerzonej DLL
/////////////////////////////////////////////////////////////////////////
void CModuleData::FreeExMem()
{
 if((ExMem!=0) && (hexmem != NULL) && (ptrex !=NULL) )
  {
	// UWAGA !!! ExMem i InExSize s niezmienne i pochodz z pliku konfig.
	::GlobalUnlock(hexmem);
	::GlobalFree(hexmem) ;
	ptrex = NULL ; hexmem = NULL;
	ExSize = 0 ;
  }
}

//////////////////////////////////////////////////////////////////////////
// Metoda ACMeasure()
// pomiar czasw konwersji i wypenienie tablicy minimalnych czasw konwersji
// A/C .
// parametry wejciowe :
//  mod - nr moduu dla ktrego odbywa si sprawdzanie
//////////////////////////////////////////////////////////////////////////
lc0_analog_in SAnalogIn;
int Buffer[160]; //bufor na prbki

void ACMeasure(unsigned char mod) //1..4
{
 int i,chan,ok=0;
 unsigned long T;
 BOOL f1=FALSE , f2=FALSE;
 unsigned char maxchan ;

  if(ModWsk[mod-1]->IsConvtable!=0)
	return;

  if(ModWsk[mod-1]->InType==0)
	maxchan = AC_CHANNELS ;
  else
	maxchan = AC_CHANNELS / 2 ;

  T=ModWsk[mod-1]->Tconv/100;
  for(i=0;i<maxchan;i++)
	 ModWsk[mod-1]->STable[i]=(unsigned int)((unsigned int)T*(i+1));

  SAnalogIn.LC0_CODE=ANALOG_INPUT;SAnalogIn.LC0_AMODULE=mod;
  SAnalogIn.LC0_ANUM=1;
  SAnalogIn.LC0_AMODE=LC0_MOD_START | LC0_MOD_NEW_PAR | LC0_MOD_SYNCHR | LC0_MOD_BLOCK;
  SAnalogIn.LC0_ASTST = 0 ;
  SAnalogIn.LC0_APER=T ;
  SAnalogIn.LC0_ACHAN = 0x81 ;
  SAnalogIn.LC0_AADDR=(int far *)Buffer;
  SAnalogIn.LC0_ALEN=160;

  SAnalogIn.LC0_APER=5000;
  SAnalogIn.LC0_ASTOP.samples=8;
  for(i=0;i<3;i++)
	{
	 LC0_AnalogIn(&SAnalogIn);
	 if(SAnalogIn.LC0_STATUS==LC0_OK)
	  {
		 f1=TRUE;
		 break;
	  }
	}

  if(f1==FALSE)
	{
	 ModWsk[mod-1]->AC_DMA = 0xff ;
	 return ;
	}
  else
	{
	 SAnalogIn.LC0_APER=10000;
	 SAnalogIn.LC0_ASTOP.samples=8;
	 SAnalogIn.LC0_ACHAN = 0x04 ;
	 for(i=0;i<3;i++)
	  {
		LC0_AnalogIn(&SAnalogIn);
		if(SAnalogIn.LC0_STATUS==LC0_OK)
		 {
		  f2=TRUE;
		  break;
		 }
	  }
	}

 /////////////////////////////////////////////////////////////////////////
 // pomiar STable[0] - praca jednokanaowa
 /////////////////////////////////////////////////////////////////////////
 SAnalogIn.LC0_ACHAN = 0x81 ;
 SAnalogIn.LC0_ASTOP.samples=8;
 do
  {
	SAnalogIn.LC0_APER=T;
	LC0_AnalogIn(&SAnalogIn);
	if(SAnalogIn.LC0_STATUS==LC0_OK)
	 {
		ok=1;
		for(i=0;i<3;i++)
		 {
		  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
		  if(SAnalogIn.LC0_STATUS!=LC0_OK)
			{
			 ok=0;
			 break;
			}
		 }
	 }

	if(ok==0)
	 T+=5;
	if(T>4*ModWsk[mod-1]->STable[0])
	 return ;
  }while(ok==0);
 ModWsk[mod-1]->STable[0]=(unsigned int)T;

 for(i=1;i<maxchan;i++)
  ModWsk[mod-1]->STable[i]=(unsigned int)((unsigned int)T*(i+1));

 if(f2==FALSE)
  return;
 //////////////////////////////////////////////////////////////////////////
 // pomiar wielokanaowy
 //////////////////////////////////////////////////////////////////////////
 for(chan=2;chan<=maxchan;chan++)
  {
	T=ModWsk[mod-1]->STable[chan-1]-20;
	SAnalogIn.LC0_ASTOP.samples=chan*3;
	SAnalogIn.LC0_ACHAN = chan ;
	ok=0;
	do
	 {
	  SAnalogIn.LC0_APER=T;
	  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
	  if(SAnalogIn.LC0_STATUS==LC0_OK)
		{
		 ok=1;
		 for(i=0;i<3;i++)
		 {
		  LC0_AnalogIn((lc0_analog_in FAR *)&SAnalogIn);
		  if(SAnalogIn.LC0_STATUS!=LC0_OK)
			{
			 ok=0;
			 break;
			}
		 }
		}

		if(ok==0)
		T+=5;
	  if(T>4000)
		T-=1;
	  if(T>4*ModWsk[mod-1]->STable[chan-1])
		return ;
	 }while(ok==0);
	ModWsk[mod-1]->STable[chan-1]=(unsigned int)T;
  }
}


//######################################################################
////////////////////////////////////////////////////////////////////////
// funkcje wewntrzne do odczytu konfiguracji z pliku konfiguracyjnego
////////////////////////////////////////////////////////////////////////
//#######################################################################

/*
 Funkcja 'FindLine'
 Szuka w pliku INI danej linii , gdzie jest podany wzorzec i j zwraca
 Parametry wywoania :
  once : 1 gdy chcemy odczyta lini z grup parametrw oddzielonych ','
  pattern : wzorzec wedug ktregp szukamy linii
  line    : znaleziona linia z wzorcem lub NULL gdy nie ma
  termination : 1 gdy chcemy zale lini z nazw sekcji karty
 Rezultat :
  wskanik na pattern
*/
char * FindLine(int once,FILE *ini , char * pattern , char * line,int termination=1)
{															  // szuka w pliku lini gdzie
 char * r;												  // jest wzorzec i zwraca t
 char l[255],c;											  //lini
 int i,ll=0;															  // zwraca wskaznik na pattern
 r = NULL ;
 fpos_t pos;

 if(once!=0)
  {
	while(1)
	 {
	  fgetpos(ini,&pos);
	  fgets(l,255,ini);
	  l[strlen(l)-1]='\0';
	  strupr(l);
	  ll=0;
	  if(l[0]=='\0')
		{
		 continue ;
		}
	  for(i=0;i<strlen(l);i++)
		{
		 c=l[i];
		 if(c>0x20 && c< 0x7F)
		 {
		  if(c==';')
			{
			 ll=1;
			 break;
			}
		 }
		}
	  if(ll==1)
		continue;
	  r = strstr(l,pattern);
	  if(r==NULL)
		fseek(ini,(unsigned long)pos,SEEK_SET);
	  else
	  strcpy(line,l);
	  return(r);
	 }
  }
 while(fgets(l,255,ini)!=NULL)
  {
	 l[strlen(l)-1]='\0';
	 strupr(l);
	 ll=0;
	 for(i=0;i<strlen(l);i++)
	  {
		c=l[i];
		if(c>0x20 && c< 0x7F)
		{
		 if(c==';')
		  {
			ll=1;
			break;
		  }
		}
	  }
	 if(ll==1)
	  continue;
	 r = strstr(l,pattern);
	 if(r!=NULL)
	  {
		strcpy(line,l);
		break ;
	  }
	 else //czy koniec biecej sekcji dotyczcej danej karty : [LC-
	  {
		if(termination ==1)
		 {
		  l[strlen(SectionTerm)]='\0';
		  r = strstr(l,SectionTerm);
		  if(r!=NULL)
			return(NULL) ;
		 }
	  }
  }
  return(r);
}


//////////////////////////////////////////////////////////////////////
// Funkcja FindParam :
// Wybiera parametr z linii podanej linii : 'Opis' = 'param' <- linia
// Parametry wejciowe :
// line : analizowana linia
// param : odczytany marametr
// Rezultat :
// wskanik na odnaleziony parametr
//////////////////////////////////////////////////////////////////////
char * FindParam(char *line , char *param)
{
 char *r = NULL , tab[255],c ;

 r=strpbrk(line,"=");
 if(r!=NULL)
  {
	r++;
	strcpy(param,r);
	int i , j=0 ;
	for(i=0;i<strlen(param);i++)
	 {
	  c=param[i];
	  if(c>0x20 && c< 0x7F)
		{
		 tab[j++]=c;
		}
	 }
	tab[j]='\0';
	strupr(tab);
	strcpy(param,tab);
	r=param;
  }

 return r ;
}

/////////////////////////////////////////////////////////////////
// Funkcja ParamToInt()
// Odczytanie parametru z biecej linii i przeksztacenie do int
// Parametry wejciowe /wy:
//  ini - handler pliku
//  nr - numer stringu z tablicy parametrw  'IniKeyMod'
// *param - przeksztacony do 'int' parametr
// Rezultat
//  LC0_OK lub kod bdu
/////////////////////////////////////////////////////////////////
int ParamToInt(FILE *ini , int nr ,int *param)
{
 char *wsk,*er ;
 char tab[100],line[255];
 int l;
 char err = LC0_OK ;

 wsk=FindLine(0,ini,IniKeyMod[nr],line)  ;
 if(wsk==NULL)
  err= LC0_BAD_CONFIG ;
 else
  {
	wsk=FindParam(line,tab);
	if(wsk==NULL)
	 err= LC0_BAD_CONFIG ;
	else
	 {
	  l = (int)strtol(tab,&er,10);
	  if(er==NULL)
		err= LC0_BAD_CONFIG ;
	  else
		*param = l;
	  }
  }

 return err ;
}


//////////////////////////////////////////////////////////////////////////
// Funkcja ParamToList()
// linia do listy parametrw oddzielonych przecinkami
// ini    - plik INI
// nr  	 - indeks tablicy z identyfikatorem parametrw
// number - ilo zidentyfikowanych parametrw
// strpar[] - tablica z tekstami poszczeglnych parametrw
// intpar[] - tablica z poszczeglnymi parametrami w postaci INT
// Rezultat LC0_OK lub kod bdu .
//////////////////////////////////////////////////////////////////////////
int ParamToList(FILE *ini,int nr,int *number,char *strpar[],int intpar[])
{
 char *wsk,c ;
 char tab[255],line[255];
 int i,j=0;

 wsk=FindLine(0,ini,IniKeyMod[nr],line)  ;
 if(wsk==NULL)
  return LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
 wsk=FindParam(line,tab);
 if(wsk==NULL)
  return LC0_BAD_CONFIG ; //bdny plik konfiguracyjny

 for(i=0;i<strlen(tab);i++)
	 {
	  c=tab[i];
	  if(c>0x20 && c< 0x7F)
		{
		 line[j++]=c;
		}
	 }
	line[j]='\0';
	strupr(line);
  //w "line" - string z parametrami i UPPER
  //akcja
  i=0;
  *number = 0;
  while(line[i]!='\0')
	{
	 //odczyt parametru
	 j=0;
	 while((line[i]!='\0')&&(line[i]!=','))
	  {
		strpar[*number][j++]=line[i++];
	  }
	 strpar[*number][j]='\0';
	 sscanf(strpar[*number],"%d",&(intpar[*number]));
	 *number+=1;
	 if(line[i]==',')
	  i++;
	}
 return LC0_OK;
}

/////////////////////////////////////////////////////////////////////
// Funkcja ParamToTab()
// Odczytanie "count" parametrw numerycznych oddzielonych ','
// Parametry wejciowe :
//  ini - handler pliku
//  nr  - numer parametru w tablicy 'IniKeyMod'
//  count - ilo parametrw do przeksztacenia (odczytu)
//  table - tablica z parametrami przeksztacanymi
//  once -  1
// Rezultat :
//  LC0_OK lub kod bdu .
//////////////////////////////////////////////////////////////////////
int ParamToTab(FILE *ini , int nr ,int count,unsigned int *table,int once)
{
 char *wsk,*er ;
 char tab[100],line[255];
 int l;
 char err = LC0_OK ;

 wsk=FindLine(1,ini,IniKeyMod[nr],line)  ;
 if(wsk==NULL)
  {
	if(once!=0)
	 err= 2 ;
	else
	 err=LC0_BAD_CONFIG ;
  }
 else
  {
	wsk=FindParam(line,tab);
	if(wsk==NULL)
	 err= LC0_BAD_CONFIG ;
	else
	 {
		wsk = tab ;
		int i ;
		for(i=0 ; i<count ; i++)
		 {
		  l = (int)strtol(wsk,&er,10);
		  if(*er == '\0' || *er == ',')
			{
			  if(*er==',')
				wsk = er+1 ;
			  table[i] = l;
			}
		  else //inny separator
			{
				err= LC0_BAD_CONFIG ; //bdny plik konfiguracyjny
				break ;
			}

		  if((*er=='\0') && (i<count-3))
			{
			 err= LC0_BAD_CONFIG ;
			 break ;
			}

		 }

	 }

  }
 return err ;
}

//////////////////////////////////////////////////////////////////////
// Funkcja SearchFile()
// szuka pliku AMBEX.INI i go ewentualnie otwiera
// path - nazwa pliku konfiguracyjnego : "AMBEX.INI"
// Rezultat
//  handler do otwartego pliku lub NULL
//////////////////////////////////////////////////////////////////////
FILE* SearchFile(char *path)
{
	char pbuf[144] ;
	UINT wret ;
	FILE *ini ;

	wret = GetWindowsDirectory((LPSTR)pbuf,sizeof(pbuf));
	if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,path);
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  strcpy(path,pbuf);
		  return ini ;
		}
	 }

	 wret = GetSystemDirectory((LPSTR)pbuf,sizeof(pbuf));
	 if(wret!=0)
	 {
	  if(pbuf[wret-1] != '\\')
		strcat(pbuf,"\\");
	  strcat(pbuf,path);
	  ini = fopen(pbuf,"r");
	  if(ini != NULL)
		{
		  strcpy(path,pbuf);
		  return ini ;
		}
	 }

	char *pt;
	pt = searchpath(path);
	if(pt == NULL)
	 {
		return NULL ;
	 }
	else
	 {
	  strcpy(path,pt);
	  ini = fopen(path,"r");
	  return ini ;
	 }
}

//////////////////////////////////////////////////////////////////////
// Funkcja ReadIniFile
// Wczytuje parametry globalne dla wszystkich moduw z pliku konfiguracyjnego
// path - scieka do pliku konfiguracyjnego
// position : zwrcona bieca pozycja w pliku konfiguracyjnym (wzkanik odczytu)
// Rezultat :
//  LC0_OK lub kod bdu
//////////////////////////////////////////////////////////////////////
int ReadIniFile(char *path , unsigned long *position)
{
	FILE *ini	;
	char *wsk , line[255],param[255],*er;
	int l ;
	char err = LC0_OK ;
	fpos_t pos;

	ini = SearchFile(path);
	if(ini==NULL)
	 err = LC0_BAD_CONFIG ;
	else
	{
	 wsk = FindLine(0,ini,"[LC-015-1612]",line,0);
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ;
	 else
	  {
		 fgetpos(ini,&pos);
		 *position =(unsigned long)pos;
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[0],line)  ;			//PATH
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
		 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
			strcpy(GData.path,param);
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[1],line)  ;			//INTTIME
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
		  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
		  {
			l = (int)strtol(param,&er,10);
			if(er==NULL)
			 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
			else
			 GData.inttime = l;
		  }
	  }
	 wsk=FindLine(0,ini,IniKeyGlob[2],line)  ;			//MODULES
	 if(wsk==NULL)
	  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
	 else
	  {
		wsk=FindParam(line,param);
		if(wsk==NULL)
			 err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
		else
		  {
			 l = (int)strtol(param,&er,10);
			 if(er==NULL)
			  err= LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
			 else
			  GData.modules = l;
		  }
	  }
	 // plik na pocztek
	 fseek(ini,0,SEEK_SET);
	 fclose(ini);
	 }
  if(err == LC0_OK)
	GData.globalinit = TRUE ;
  return err ;
}


///////////////////////////////////////////////////////////////////////////
// Funkcja 'ReadIniModuleAll'
// Odczytuje parametry z pliku konfiguracyjnego (AMBEX.INI) dotyczce wszystkich
// moduw [1]..[4] -> A..D . 'modname'
// przeznaczenie do statycznego adowania przy starcie biblioteki
// path - scieka do pliku INI
// position : pozycja od ktrej naley przeszukiwa plik
// Rezultat :
//  LC0_OK lub kod bedu
//////////////////////////////////////////////////////////////////////////
int ReadIniModuleAll(char *path , unsigned long position)
{
  FILE *ini	;
  char *wsk , line[255];
  int l ;
  char err = LC0_OK ;
  char *num[] = {"[MODULE A]","[MODULE B]"};
  int count = 1 ,i;
  unsigned char modname ; //numer moduu
  char strp[20][20];  //20 parametrw po 20 znakw
  char *strpar[20];
  int intpar[20];

  for(l=0;l<20;l++)
	strpar[l]=strp[l];

  ini = fopen(path,"r");
  if(ini==NULL)
	 err = LC0_BAD_CONFIG ; //bdny plik AMBEX.INI
  else
	{
	 fseek(ini,position,SEEK_SET);
	 do
	  {
		//odczyt identyfikatora sekcji , wana kolejno [1] -> [4]

	  wsk = FindLine(0,ini,num[count-1],line) ; //szukamy identyfikatora [MODULE X]
	  if(wsk==NULL) //nie znaleziono
		{
		 err = LC0_NO_MODULE ;
		 fseek(ini,position,SEEK_SET);//cofnicie pliku na pocztek sekcji
		}
	  else
		err=LC0_OK;
	  count++ ;
	  modname=count-1;
	  if(err==LC0_OK) //znaleziono waciw sekcj dla wybranego moduu
		{
		 // czytamy poszczeglne parametry , kolejno konieczna
		 while(1)
		  {
			//"AD_CONVERTER"
			//fgets(line,255,ini);

			err=ParamToList(ini,0,&l,strpar,intpar);
			if(err==LC0_OK)
			 {
				err=LC0_BAD_CONFIG;
				for(i=0;i<4;i++)
				 {
				  if(strcmp(strpar[l-1],ADSType[i])==0)
					{
					  ModWsk[modname-1]->ADType=i;
					  err=LC0_OK;
					  break;
					}
				 }
				if(err!=LC0_OK)
				 break;
			 }
			else
			 break;

			err = ParamToInt(ini , 1 ,&l) ;   //TCONV
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->Tconv = l;
			 }
			else
			 break;

			///////////////////////////////////////////////////////////
			err = ParamToTab(ini , 2 ,16,ModWsk[modname-1]->STable,1); //CONVTABLE
			if(err==2)
			 ModWsk[modname-1]->IsConvtable = 0;
			else
			 {
			  ModWsk[modname-1]->IsConvtable = 1;
			  if(err==LC0_BAD_CONFIG)
				break;
			 }

			//PGA_TYPE
			err=ParamToList(ini,3,&l,strpar,intpar);
			if(err==LC0_OK)
			 {
				err=LC0_BAD_CONFIG;
				for(i=0;i<3;i++)
				 {
				  if(strcmp(strpar[l-1],PGAType[i])==0)
					{
					  ModWsk[modname-1]->PGA=i;
					  err=LC0_OK;
					  break;
					}
				 }
				if(err!=LC0_OK)
				 break;
			 }
			else
			 break;

			err = ParamToInt(ini , 4 ,&l) ; //EXTMEM :
			if(err==LC0_OK)
			 {
			  if(l!=0)
				{
				 ModWsk[modname-1]->ExMem = 1;
				 ModWsk[modname-1]->InExSize = (unsigned long int)((unsigned long int)l*1024); //bo w KB
				}
			  else
				{
				 ModWsk[modname-1]->ExMem = 0;
				 ModWsk[modname-1]->InExSize = 0; //bo w KB
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 5 ,&l) ; //MODE : 1 - MASTER reszta - SLAVE
			if(err==LC0_OK)
			 {
			  if(l==1)
				ModWsk[modname-1]->mode = l;
			  else
				ModWsk[modname-1]->mode = 0;
			 }
			else
			 break;

			err = ParamToInt(ini , 6 ,&l) ;   //FREQUENCY MHZ
			if(err==LC0_OK)
			 {
			  if(l==10)
				ModWsk[modname-1]->CLK = l;
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 7 ,&l) ;   //IRQ
			if(err==LC0_OK)
			 {
			  if(l==3 || l==5 || l==10 ||l==11 ||l==12 || l==0)
				{
				 ModWsk[modname-1]->IRQ = l;

				 if(l==0)
				  ModWsk[modname-1]->IRQ = 0xff;
				}
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			err = ParamToInt(ini , 8 ,&l) ;   //CHANNELS C/A
			if(err==LC0_OK)
			 {
			  if(l==0 || l==1 || l==2)   // l==0 oznacza brak C/A
				ModWsk[modname-1]->CA_channels = l;
			  else
				{
				  err = LC0_BAD_CONFIG ;
				  break ;
				}
			 }
			else
			 break;

			//AD_InType
			err=ParamToList(ini,9,&l,strpar,intpar);
			if(err==LC0_OK)
			 {
				err=LC0_BAD_CONFIG;
				for(i=0;i<2;i++)
				 {
				  if(strcmp(strpar[l-1],InType[i])==0)
					{
					  ModWsk[modname-1]->InType=i;
					  err=LC0_OK;
					  if(i==1) //BIP
						ModWsk[modname-1]->PSTSW &= 0xff7f ;
					  break;
					}
				 }
				if(err!=LC0_OK)
				 break;
			 }
			else
			 break;

			err = ParamToInt(ini , 10 ,&l) ;   //A/C_V1
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->AC_V1 = l;
			 }
			else
			 break;

			err = ParamToInt(ini , 11 ,&l) ;   //A/C_V2
			if(err==LC0_OK)
			 {
				ModWsk[modname-1]->AC_V2 = l;
			 }
			else
			 break;

			err=ParamToList(ini,12,&l,strpar,intpar);
			if(err==LC0_OK)
			 {
			  if((l==0)||(l>2))
				{
				 err = LC0_BAD_CONFIG ;
				 break ;
				}
				for(i=0;i<l;i++)
				{
				 if(intpar[i]==5 || intpar[i]==6 || intpar[i]==0)
				  {
					if(i==0)
					 ModWsk[modname-1]->AC_DMA = intpar[i];
					else
					 ModWsk[modname-1]->AC_DMA2 = intpar[i];
					if(intpar[i]==0)
					 {
					  if(i==0)
						ModWsk[modname-1]->AC_DMA = 0xff;
					  else
						ModWsk[modname-1]->AC_DMA2 = 0xff;
					 }
					}
				  else
					{
					  err = LC0_BAD_CONFIG ;
					  break ;
					}
				}
				if(l==2)
				 if((ModWsk[modname-1]->AC_DMA != 0xff)&&(ModWsk[modname-1]->AC_DMA2 != 0xff))
				  if(ModWsk[modname-1]->AC_DMA == ModWsk[modname-1]->AC_DMA2)
					{
					  err = LC0_BAD_CONFIG ;
					  break ;
					}
			 }
			else
			 {
			  err = LC0_BAD_CONFIG ;
			  break ;
			 }

			if(ModWsk[modname-1]->CA_channels !=0)
			 {
			  err = ParamToInt(ini , 13 ,&l) ;   //C/A1_V1
			  if(err==LC0_OK)
				{
				 ModWsk[modname-1]->CA1_V1 = l;
				}
			  else
				break;
			  err = ParamToInt(ini , 14 ,&l) ;   //C/A1_V2
			  if(err==LC0_OK)
				{
				 ModWsk[modname-1]->CA1_V2 = l;
				}
			  else
				break;
			  if(ModWsk[modname-1]->CA_channels ==2)
				{
				 err = ParamToInt(ini , 15 ,&l) ;   //C/A2_V1
				 if(err==LC0_OK)
				  {
					ModWsk[modname-1]->CA2_V1 = l;
				  }
				 else
				  break;
				 err = ParamToInt(ini , 16 ,&l) ;   //C/A2_V2
				 if(err==LC0_OK)
				  {
					ModWsk[modname-1]->CA2_V2 = l;
				  }
				 else
				  break;
				}
			  err = ParamToInt(ini , 17 ,&l) ;   //C/A_DMA
			  if(err==LC0_OK)
				{
				 if(l==7 || l==0)          //0 oznacza brak DMA
				  {
					ModWsk[modname-1]->CA_DMA = l;
					if(l==0)
					 ModWsk[modname-1]->CA_DMA = 0xff;
				  }
				 else
				  {
					err = LC0_BAD_CONFIG ;
					break ;
				  }
				}
			  else
				break;
			  //////////////////////////////////////////////////////////////////
			  err = ParamToTab(ini , 18 ,2,ModWsk[modname-1]->CA_Table,0);
			  if(err!=LC0_OK)
				break;
			 }

			//////////////////////////////////////////////////////////////////
			// pomylne adowanie moduu gdy rzeczywicie istnieje w pamici
		  err = ModWsk[modname-1]->MemoryTest();
		  if(err==LC0_OK)
			 err = CheckModule(ModWsk[modname-1]->BaseAdr);
		  if(err==LC0_OK)
			{
			 ModWsk[modname-1]->IsLoaded = TRUE ;
			 ModWsk[modname-1]->ClearDACs();
			}
			fseek(ini,position,SEEK_SET);
			break;
		  }
		}
		ModWsk[modname-1]->InitError =err ;
	  }
	  while(count<3);
	 fclose(ini);
	}
 return err ;
}

//////////////////////////////////////////////////////////////////////
// Funkcja 'LoadParameters'
// Funkcja adujca dane z pliku AMBEX.INI do pamici
// ustawia pole GData.Error
// Jest wywoywana w LibMain()
//////////////////////////////////////////////////////////////////////
void  LoadParameters(void)
{
  char errcode ;
  unsigned long position;

	strcpy(config_file,ini_file)    ;
	errcode = ReadIniFile(config_file,&position);
	if(errcode != LC0_OK) //bdna konfiguracja
	 {
	  GData.Error = errcode ;
	  for(int i=0;i<2;i++)
		{
		 ModWsk[i]->InitError=LC0_BAD_CONFIG;
		}
	  return ;
	 }
  GData.globalinit = TRUE ;
  errcode = ReadIniModuleAll(config_file,position);
  if(errcode==LC0_BAD_CONFIG)
	GData.Error = errcode ;
  else
	GData.Error = LC0_OK ;
}

//////////////////////////////////////////////////////////////////////////
// Funkcja WaitForALevel
// Warunek start od poziomu na wybranym wejciu analogowym
// parametry wejciowe :
//  par[] - tablica z parametrami przetwarzania
//  *errex - dodatkowy kod statusu
//  check - 0 : gdy wywoanie z funkcji LC0_AnalogIn
// Rezultat : kod ststusu
// channel : b0..b5 - nr kanau ;
//			    b6 - 0 - reakcja na zbocze ; 1 - na poziom
//				 b7 - 0 - zbocze opadajce/poniej poziomu
//					   1 - zbocze narastajce/powyej poziomu
// level	: b0..b11 - poziom komparacji wyrazony w kodzie przetwornika
//			: b12..b15 - margines zakce - ilo konwersji A/C na potw. war.startu
//////////////////////////////////////////////////////////////////////////
char WaitForALevel( unsigned char par[],char *errex,int check)
{
 char errcode = LC0_OK ;
 char val ;
 unsigned int level,val16,num,ccount=0 ;
 BOOL type ; //zbocze/poziom
 BOOL value ;//
 unsigned char maxchan ;

  *errex = LC0_OK ;
 if((par[0] >= LC0_MODA) && (par[0]<=LC0_MODB))
  {
	errcode = ModWsk[(int)(par[0])-1]->CheckApp() ;
	if(errcode!=LC0_OK)
	 {
		if(errcode == LC0_NO_MODULE)
		 *errex = LC0_E_NO_MODULE ;
		else
		 *errex = LC0_E_MOD_UNABLE ;
		return LC0_ILL_START ;
	 }

	 if(check==1)
	  if(ModWsk[par[0]-1]->PAC.DevBusy)
		{
		 *errex = LC0_E_MOD_UNABLE ;
		 return LC0_ILL_START ;
		}


	 if(par[1]!=1)
	  {
		*errex = LC0_E_NONEX_DEV ;
		return LC0_ILL_START;
	  }


	 if(ModWsk[par[0]-1]->InType==0) //UNI
		maxchan = AC_CHANNELS ;
	 else // BIP
		maxchan = AC_CHANNELS / 2 ;

	 //sprawdzamy numer kanau
	 val = par[2] & 0x3f ;
	 if(val == 0x00 || val > maxchan)
	  {
		*errex = LC0_E_BAD_CHAN	;
		return LC0_ILL_START ;
	  }
	 if((par[2] & 0x40) != 0)
	  type = TRUE ;
	 else
	  type = FALSE ;

	 if((par[2] & 0x80) != 0)
	  value = TRUE ;
	 else
	  value = FALSE ;

	level = ((unsigned int)par[4]<<8) + (unsigned int)par[3];
	val16 = level & 0x0fff;
	num = level >>12 ;

  }
 else
  {
	 *errex=LC0_E_NO_MODULE ;
	 return LC0_ILL_START ;
  }
 ////////////////////////////////////////////////////////////////////////////
 // akcja - pomiar programowy wybranego kanau analogowego
 ////////////////////////////////////////////////////////////////////////////
 unsigned char mod = par[0]-1 ;
 unsigned int base = ModWsk[mod]->BaseAdr ;
 unsigned int samp,samppop=0 ;
 unsigned char val1,mem;
 BOOL endp=FALSE,first=TRUE,U2 ;
 MSG mes ;

 if((ModWsk[mod]->ADType == 3) && (ModWsk[mod]->AC_V1 <0)) //U2
  U2 = TRUE ;
 else
  U2 = FALSE ;

 ModWsk[mod]->ResetAC();
 mem = inportb(base+RAM_READ) ;
 ModWsk[mod]->ResetAC();
 outportb(base+RAM_WRITE,0xc0 + 16*(ModWsk[mod]->VPGA-1)+val-1);
 ModWsk[mod]->ResetAC();

 unsigned int norm = ModWsk[mod]->PSTSW ;

 outportb(base+CTC_0+3, 0xb2);
 val1 = (unsigned char)(ModWsk[mod]->PAC.PGACnt & 0x00ff) ;
 outportb(base+CTC_0+2,val1);
 val1 = (unsigned char)(ModWsk[mod]->PAC.PGACnt >> 8) ;
 outportb(base+CTC_0+2,val1);


 ModWsk[mod]->PSTSW |=_ENABLE_PRETRIG_ADC | _ENABLE_SAMPLE_IN |
 _ENABLE_DMA_ADC | _ENABLE_IRQ ;
 ModWsk[mod]->PSTSW &= 0xffcf ;
 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;

 outport(base+SET_EN_ADC, 0);
 while(1)
  {
	outport(base+ADC_ST_PR,0);
	while(1)
	 {
	  if((inport(base+STATUS_READ) & 0x0001)!=0)
		{
		 samp = inport(base + ADC_READ);
		 if(U2)
		  {
			 if(samp <=0x07ff)
			  samp = samp + 0x0800 ;
			 else
			  samp = samp - 0x0800 ;
		  }
		 if(first)
		  first=FALSE;
		 else
		  {
			if(type==FALSE)
			 {
			  if(value==0)
				{
				 if(samp <= samppop)
				  {
					if(samp!=samppop)
					 ccount ++ ;
					if(ccount > num)
					 {
					  if((samp <= val16)&&(samppop >=val16))
						{
						 endp = TRUE ;
						 break ;
						}
					  ccount = num + 1 ;
					 }
				  }
				 else
				  if(ccount > 0)
					ccount --;
				}
			  else
				{
				  if(samp >= samppop)
					{
					 if(samp!=samppop)
					  ccount ++ ;
					 if(ccount > num)
					 {
					  if((samp >= val16)&&(samppop <= val16))
						{
						 endp = TRUE ;
						 break ;
						}
					  ccount = num + 1 ;
					 }
					}
				  else
					if(ccount >0)
					ccount --;
				}
			 }
			else            //komparator poziomu
			 {
				if(value==0)
				 {
				  if(samp <= val16)
					ccount ++ ;
				  else
					ccount = 0;
				 }
				else
				 {
				  if(samp >= val16)
					ccount ++  ;
				  else
					ccount = 0;
				  }
				if(ccount>num)
				 {
				  endp = TRUE ;
				  break ;
				 }
			 }
		  }
		 samppop = samp ;
		 break ;
		}
	  /////////////////////////////////////////////////////
	  // ewentualnie break
	  /////////////////////////////////////////////////////
	  if(ModWsk[mod]->SynEnable)
		{
		 if(IntBreak(&mes)==FALSE)
		  {
			ModWsk[mod]->ResetAC();
			ModWsk[mod]->MessageBreak();
			*errex = LC0_E_BROKEN_WAIT ;
			errcode = LC0_BROKEN ;
			break ;
		  }
		}
	 }
	if((errcode!= LC0_OK) || (endp == TRUE) )
	 break ;
  }

 ModWsk[mod]->ResetAC();
 ModWsk[mod]->PSTSW = norm;
 outport(base+STATUS_WRITE,ModWsk[mod]->PSTSW) ;

 ModWsk[mod]->ResetAC();
 outportb(base+RAM_WRITE,mem);
 ModWsk[mod]->ResetAC();

 return errcode ;
}

///////////////////////////////////////////////////////////////////////////
// Funkcja WaitForStart()
// Funkcja testujca warunek startu operacji A/C , C/A,Din,Dout
// stst   - typ warunku startu
// par[]  - 4 kolejne parametry unsigned char ze struktury lc0_start
// ptime  - dla typu LC0_STIME warto czasu
// *errex - dodatkowy kod bdu
// MOD    - nr moduu  ktry wywoa funkcj sprawdzania warunkw startu
// check  - 0 gdy wywoanie z funkcji LC0_AnalogIn
// return : kod bdu LC0_STATUS
///////////////////////////////////////////////////////////////////////////
char FAR PASCAL WaitForStart(unsigned char stst , unsigned char par[],
						unsigned long ptime , char *errex,unsigned char MOD,
						int check)
{
  char errcode ;
  BOOL cond = TRUE;
  unsigned char val,nport;
  int modnum ;
  unsigned char mask[] = {0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};
  unsigned char sday[] ={31,28,31,30,31,30,31,31,30,31,30,31};
  unsigned int aport,val16;
  tm *td ;
  time_t t1,t2;
  struct time tt;
  struct date dd;
  MSG mes ;

  BOOL jump = FALSE ;

  *errex = LC0_E_OK ;
  if(stst == LC0_SIMMED)
	return LC0_OK ;
  if(stst == LC0_SHARD )
	return LC0_ILL_START_CODE ;
  if(stst >LC0_SANALOG)
	return LC0_ILL_START_CODE ;

  if(stst == LC0_SANALOG)
	{
	 errcode = WaitForALevel(par,errex,check) ;
	 return errcode ;
	}

  if(stst>=LC0_SLEVEL && stst <=LC0_SDIG_NE)
	{
	 if(par[0]<LC0_MODA || par[0]>LC0_MODB )
	  {
		*errex = LC0_E_NO_MODULE ;
		return LC0_ILL_START;
	  }
	 errcode = ModWsk[(int)(par[0])-1]->CheckApp() ;
	 if(errcode!=LC0_OK)
	  {
		if(errcode == LC0_NO_MODULE)
		 *errex = LC0_E_NO_MODULE ;
		else
		 *errex = LC0_E_MOD_UNABLE ;
		return LC0_ILL_START ;
	  }

	 if((par[1]==0) || (par[1]>DIN_NUM ))
	  {
		*errex = LC0_E_NONEX_DEV ;
		return LC0_ILL_START;
	  }
	 else
	  {
		nport=par[1]; //1 lub 2
		aport = DIG_IN_READ  ;
	  }

	 if(stst == LC0_SLEVEL || stst == LC0_SSLOPE)
	  {
		 if((par[2]>8) || (par[2]==0))
			{
				*errex = LC0_E_NONEX_DEV ;
				return LC0_ILL_START;
			}
	  }
	 else
	  {
		par[3] = par[3] & par[2] ;
	  }
	 /////////////////////////////////////////////////////////////////////////
	 // ptla odczytujca port cyfrowy
	 /////////////////////////////////////////////////////////////////////////
	 modnum = par[0] -1 ;
	 do
	  {

		 if(ModWsk[MOD-1]->SynEnable)
		  {
			 if(IntBreak(&mes)==FALSE)
			  {
				ModWsk[MOD-1]->MessageBreak();
				cond = FALSE ;
				*errex = LC0_E_BROKEN_WAIT ;
				return LC0_BROKEN ;
			  }
		  }

		 val16=inport(ModWsk[modnum]->BaseAdr + aport);
		 if(nport==1)
		  val =(unsigned char)(val16 & 0x00ff) ;
		 else
		  val =(unsigned char)(val16 >> 8) ;
		 switch(stst)
		  {
			 case	LC0_SLEVEL		:
										 val = val & mask[par[2]-1];
										 if(par[3]==0) //
											{
											 if(val==0)
											  cond=FALSE ; //
											}
										  else         //
											{
											  if(val!=0)
												cond = FALSE ;//
											}
										 break;
			 case	LC0_SSLOPE		:val = val & mask[par[2]-1];
										 if(par[3]!=0)
										  {
											if(!jump)
											 {
												if(val==0)
												 jump = TRUE ;
											 }
											else
											 {
												if(val!=0)
												 cond = FALSE ; //O.K.
											 }
										  }
										 else     // 1->0
										  {
											if(!jump)
											 {
												if(val!=0)
												 jump = TRUE ;
											 }
											else
											 {
												if(val==0)
												 cond = FALSE ; //O.K.
											 }
										  }
										 break;
			 case	LC0_SDIG_EQ		:
			 case	LC0_SDIG_NE		:val = val & par[2] ;
										 val = val ^ par[3] ;
										 if(stst==LC0_SDIG_EQ )
											{
											 if(val==0)
											  cond = FALSE ; //O.K.
											}
										  else
											{
											 if(val!=0)
											 cond = FALSE ; //O.K.
											}
										 break;

		  }

	  }while(cond==TRUE);

	 //////////////////////////////////////////////////////////////////////////

	}
  else
	{
	  if(stst==LC0_SDATE)
		{
		  if((par[0]>=60)||(par[1]>=60)||(par[2]>=24))
			{
			  *errex = LC0_E_BAD_TIME ;
			  return LC0_ILL_START ;
			}
		  //dzie miesica
		  t1=time(NULL);
		  td = gmtime(&t1);
		  if(par[3]>sday[td->tm_mon])
			{
			  *errex = LC0_E_BAD_DATE ;
			  return LC0_ILL_START ;
			}
		}

	  t1=time(NULL);
	  do
		{
		 if(ModWsk[MOD-1]->SynEnable)
		  {
			 if(IntBreak(&mes)==FALSE)
			  {
				ModWsk[MOD-1]->MessageBreak();
				cond = FALSE ;
				*errex = LC0_E_BROKEN_WAIT ;
				return LC0_BROKEN ;
			  }
		  }

		 t2=time(NULL);
		 if(stst==LC0_STIME) //czas
		  {
			 if(difftime(t2,t1)>=ptime)
			  {
				cond = FALSE ;
			  }
		  }
		 else               //data
		  {
			 getdate(&dd);
			 gettime(&tt);
			 if((dd.da_day==par[3]) && (tt.ti_hour==par[2]) && (tt.ti_min==par[1])
			 && (tt.ti_sec==par[0]))
				{
				  cond = FALSE ;
				}
		  }
		}while(cond==TRUE);
	}

 return LC0_OK ;
}

///////////////////////////////////////////////////////////////////////////////
// Funkcja IntBreak
// Wewntrzna procedura monitorowania warunkw startu i operacji synchronicznych
// Wejcie : wskaznik do struktury opisu komunikatu
// Wyjcie : TRUE gdy nie przerwana FALSE - przerwanie
////////////////////////////////////////////////////////////////////////////////
BOOL IntBreak(MSG *mes)
{

 if(GetAsyncKeyState(KEYBREAK1)& 0x8000)
  {
	 while(::PeekMessage(mes,NULL,WM_KEYFIRST,WM_KEYLAST,PM_REMOVE|PM_NOYIELD))
	 {
		 //i++;
	 }
	 while(::PeekMessage(mes,NULL,WM_MOUSEFIRST,WM_MOUSELAST,PM_REMOVE|PM_NOYIELD))
	 {
		 //i++;
	 }
	  return FALSE ;
	}
  return TRUE ;
}

////////////////////////////////////////////////////////////////////////
// value[32] = *div1**div2
////////////////////////////////////////////////////////////////////////
void dividers(unsigned long value, unsigned int *div1,unsigned int *div2)
{
 long temp;
 int rest,trest,tdiv1,tdiv2,r;

 *div2 = 1;
 do {(*div2)++ ; temp=value / *div2 ;}while(temp>0xFFFFL);
 *div1 = (UINT)temp ;
 rest = (int)(value - (*div1)*(*div2));
 r=abs((int)(value-((*div1) +1)* (*div2)));
 rest = rest < r ? rest : (*div1)++,r ;
 trest = rest;tdiv1=*div1;tdiv2=*div2 ;
 while((trest!=0) && (tdiv1>tdiv2))
  {
	 tdiv2++;
	 tdiv1=(UINT)(value/tdiv2);
	 trest=(int)(value - tdiv1*tdiv2) ;
	 r=abs((int)(value-(tdiv1+1)*tdiv2));
	 trest = trest < r ? trest : tdiv1++ ,r;
	 if(trest<rest)
	  {
		rest = trest;
		*div1=tdiv1;
		*div2=tdiv2;
	  }
  }
}

// koniec

#define LC0_FROM_DMA		0
#define LC0_TO_DMA		1

#define LC0_EXTMEM		0
#define LC0_PROG			1


// sprawdzenie czy modu jest zainstalowany
char CheckModule(unsigned int badr)
{
 char err = LC0_OK ;
 return(err) ;
}


/////////////////////////////////////////////////////////////////////////
// Funkcja ProgDMA16()
// Programowanie kanaw 16-o bitowych DMA 8037A
// kanal - nr kanalu 5,6,7
// tryb	- 1 - single ; 0-block
// cykl	- 1 - b.cykliczny
// zapis	- 1 - zapis do portu ; 0 - odczyt z portu
// il_s	- ilo sw transmisji <  128KB
// fadres - adres fizyczny 32-bitowy pocztku bufora
// zwraca warto rejestru strony DMA
/////////////////////////////////////////////////////////////////////////
unsigned char ProgDMA16(int kanal , int tryb , int cykl , int zapis , unsigned int il_s ,
				  unsigned long int fadres)
{
  unsigned  LicznAdrKan    ;
	unsigned  LicznTransmisji ;
	unsigned  RejStrony 	;

	unsigned int RejStanu	;
	unsigned int RejRozk	;
	unsigned int RejMaskiKan	;
	unsigned int RejTrybu	;
	unsigned int MasterFlipFlop ;
	unsigned char value	;
	unsigned int  adres		;
	unsigned char strona		;
	unsigned long real_adr,x 	;
	unsigned char xxx[10];
	unsigned char maska[]={1,2,4,8,16,32,64,128};
	int j=0,i;

	MasterFlipFlop = 0xd8 ;
	RejStanu	  		= 0xd0 ;
	RejRozk	  		= 0xd0 ;
	RejMaskiKan		= 0xd4 ;
	RejTrybu	  		= 0xd6 ;

	real_adr = fadres;

	value = 0;
	if(tryb==1)
	 value = 0x40 ;
	else
	 value = 0x80 ;
	if(cykl==1)
	 value = value | maska[4]  ;

	if(zapis==1)
	 value = value | maska[3]  ;
	else
	 value = value | maska[2]  ;

	outportb(RejRozk,0x00);

	switch (kanal)
	 {
		case  5		: 	LicznAdrKan     = 0xc4 ;
							LicznTransmisji = 0xc6 ;
							RejStrony	  = 0x8b ;
							outportb(RejMaskiKan,0x05) ;
							value = value | maska[0];
							break;
		case  6		: 	LicznAdrKan     = 0xc8 ;
							LicznTransmisji = 0xca ;
							RejStrony	  = 0x89 ;
							outportb(RejMaskiKan,0x06) ;
							value = value | maska[1];
							break;
		case  7		: 	LicznAdrKan     = 0xcc ;
							LicznTransmisji = 0xce ;
							RejStrony	  = 0x8a ;
							outportb(RejMaskiKan,0x07) ;
							value = value | maska[0];
							value = value | maska[1];
							break;

	 };
	for(i =0 ; i<100 ;i++)
	  j++;
	outportb(RejTrybu,value) ;

  x=real_adr & 0x01ffffL ;
  adres=(unsigned int)(x >> 1) ;
  strona=(unsigned char)((real_adr & 0xff0000L) >> 16) ;
  real_adr = ((unsigned long)adres << 1) | ((unsigned long)strona << 16);

  xxx[0] = (unsigned char)(adres & 0x00ff);
  xxx[1] = (unsigned char)((adres >> 8) & 0x00ff);
  xxx[2] = (unsigned char)(il_s & 0x00ff);
  xxx[3] = (unsigned char)((il_s >> 8) & 0xff);

  outportb(MasterFlipFlop,0xff);
  outportb(LicznTransmisji,xxx[2]) ;
  outportb(LicznTransmisji,xxx[3]);

  outportb(RejStrony,strona) ;
  outportb(MasterFlipFlop,0xff);
  outportb(LicznAdrKan,xxx[0]);
  outportb(LicznAdrKan,xxx[1]);

  inportb(RejStanu);

  return(strona);
}

//////////////////////////////////////////////////////////////////////////////
// Funkcja disableDMA16()
// Zablokowanie wybranego kanau DMA na czas programowania
//////////////////////////////////////////////////////////////////////////////
void disableDMA16(int kanal)
 {
	unsigned RejMaskiKan = 0xd4 ;

	 switch(kanal)
	  {
		 case 5   :outportb(RejMaskiKan,0x05) ;
					  break;
		 case 6	 :outportb(RejMaskiKan,0x06) ;
					  break ;
		 case 7	 :outportb(RejMaskiKan,0x07) ;
					  break ;
	  };
 }

////////////////////////////////////////////////////////////////////////////
// Funkcjs WaitForEndCA()
// oczekiwanie na koniec transmisji DMA dla funkcji Analog_Output
// zwraca odpowiedni kod bdu : LC0_BROKEN (=> RUN) lub LC0_OK
// Parametry :
// strona : nr strony DMA przy pierwszym zaprogramowaniu
// nst	 : liczba segmentw danych do zgromadzenia == ilo przeprogramowa r.stron
// est	 : liczba b. ostatniej transmisji : do liczn. transmisji wpisa =-1 gdy != 0
// modnum : nr moduu
// NRMNUM : wskanik do LC0_NRMNUM
// cykl	 : 1 - oznacza prac z b. cyklicznym DMA gdy il. prbek <32K
// shard  : 1 wyzwolenie sprztowe
// norm	 : sowo spoczynkowe STATUS_WRITE
// sprawdza wcinicie CTRL-BREAK
//
// Kuriozum !!! nie ma obsugi (bo nie ma mozliwoi) sprztowego koca transmisji
////////////////////////////////////////////////////////////////////////////
char WaitForEndCA(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						int cykl,
						BOOL shard ,
						unsigned int norm ,
						unsigned long int *NRMNUM)
{
 char errcode = LC0_OK;
 unsigned int  x;
 unsigned char v1=0xff,v2=0xff ;
 MSG mes ;
 unsigned int bxx = base+STATUS_WRITE;
 unsigned char mmm =kanDMA-4 ;

 outport(bxx,ModPtrCA->PSTSW);
 if(!shard)
  outport(base+SET_EN_DAC ,0) ;
 outportb(0xd4,mmm);
  if(cykl==0)
	{
	 while(1)
	  {

		if((inportb(0xd0) & maska[mmm]) != 0)
		 {
		  if(nst==0)
			{
			 outport(bxx,norm);
			 ModPtrCA->PSTSW = norm ;
			 break ;
			}
		  else
			{
			 if(st==nst)
			  {
				outport(bxx,norm);
				ModPtrCA->PSTSW = norm ;
				break ;
			  }

			 outportb(0xd4,kanDMA) ;
			 strona+=2;
			 st++;
			 outportb(RejStrony,strona);
			 if(st==nst)
			  {
				v1=v3;
				v2=v4;
			  }
			 outportb(0xd8,0xff);
			 outportb(LicznTransmisji,v1) ;
			 outportb(LicznTransmisji,v2);
			 outportb(0xd4,mmm);
			 continue ;
			}
		 }

		if(ModPtrCA->SynEnable)
		 {
		  if(ModPtrCA->AsyncEnable==0)
			{
			 outport(bxx,norm);
			 ModPtrCA->PSTSW = norm ;
			 ModPtrCA->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		  if(IntBreak(&mes)==FALSE)
			{
			 outport(bxx,norm);
			 ModPtrCA->PSTSW = norm ;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 }
	  }
	 }
	else
	 {
	  while(1)
		{
		 if(ModPtrCA->AsyncEnable==0)
			{
			 outport(bxx,norm);
			 ModPtrCA->PSTSW = norm ;
			 ModPtrCA->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 if(IntBreak(&mes)==FALSE)
		  {
			outport(bxx,norm);
			ModPtrCA->PSTSW = norm ;
			errcode = LC0_BROKEN ;
			break ;
		  }
		}
	 }

 ModPtrCA->ResetCA();

 outportb(0xd8,0xff); //przerzutnik MASTER
 v1=inportb(LicznTransmisji); //LSB licznik
 v2=inportb(LicznTransmisji); //MSB licznik
 x=(v2<<8) + v1 ;
 if((nst==0) || (st==nst))
  x = est -x ;
 else
  if(st<nst)
	x = (unsigned int)65535 - x ;
 *NRMNUM = st*65536 + x ;
 return(errcode);
}

////////////////////////////////////////////////////////////////////////////
// Funkcja WaitForEndAC()
// oczekiwanie na koniec transmisji DMA dla funkcji Analog_Input
// zwraca odpowiedni kod bdu : LC0_OVERRUN , LC0_BROKEN (=> RUN) lub LC0_OK
// Parametry :
// strona : nr strony DMA przy pierwszym zaprogramowaniu
// nst	 : liczba segmentw danych do zgromadzenia == ilo przeprogramowa r.stron
// est	 : liczba b. ostatniej transmisji : do liczn. transmisji wpisa =-1 gdy != 0
// modnum : nr moduu
// ARMNUM : wskanik do LC0_ARMNUM
// page   : 0 - tryb bez gubienia prbek ; 1- z gubieniem : NIE UYWAMY W OGLE
// sprawdza wcinicie CTRL-BREAK
// base : adres bazowy moduu
// kanDMA i 2 : numery kanaw DMA
// shard : czy start sprztowy
// norm : sowo normalizacyjne
// cycl : praca cykliczna
// lpret : ilo prbek pretriggeringu
//
// Kuriozum !!! nie ma obsugi (bo nie ma mozliwoi) sprztowego koca transmisji
////////////////////////////////////////////////////////////////////////////
char WaitForEndAC(int DMAMode ,
						unsigned char strona,
						unsigned char strona2,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned char page,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char kanDMA2,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char LicznTransmisji2,
						unsigned char RejStrony2,
						unsigned char v3,
						unsigned char v4,
						unsigned char v5,
						unsigned char v6 ,
						unsigned int base,
						BOOL shard,
						unsigned int norm ,
						BOOL cycl,
						unsigned long int *lpret ,
						unsigned  int *ARBUF,
						unsigned long int *ARMNUM)
{
 char errcode = LC0_OK;
 unsigned int  x;
 unsigned char v1=0xff,v2=0xff,cl,ch ;
 MSG mes ;
 unsigned int bxx = base+STATUS_WRITE , wxx,pb;
 unsigned char mmm =kanDMA-4 ;
 unsigned char mmm2 =kanDMA2-4 ;
 unsigned char mb=mmm,stb=strona2,mp=mmm;
 unsigned char kanDMAb , RejStronyb,LicznTransmisjib=LicznTransmisji2 ;

 BOOL strx = FALSE , fDMA = TRUE ;
 unsigned char v5l , v5h ;

 if(cycl)
  {
	pb=ModPtrAC->SynEnable;
	ModPtrAC->SynEnable = 1;
  }
 wxx =(ModPtrAC->PSTSW) & 0xffef ;

 outportb(0xd4,mmm);
 if(DMAMode!=0 )
  outportb(0xd4,mmm2);

 outport(bxx,ModPtrAC->PSTSW);
 if(!shard)
  outportb(base+SET_EN_ADC ,0) ;
 switch(DMAMode)
  {
	case 0 :
	 while(1)
	  {

		if((inportb(0xd0) & maska[mmm]) != 0)
		 {
		  if(nst==0)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 break ;
			}
		  else
			{
			 if(page!=0)
				outport(bxx,wxx );

			 if(st==nst)
			  {
				outport(bxx,norm);
				ModPtrAC->PSTSW = norm ;
				break ;
			  }

			 outportb(0xd4,kanDMA) ;
			 strona+=2;
			 st++;

			 outportb(RejStrony,strona);
			 if(st==nst)
			  {
				v1=v3;
				v2=v4;
			  }
			 outportb(0xd8,0xff);
			 outportb(LicznTransmisji,v1) ;
			 outportb(LicznTransmisji,v2);

			 outportb(0xd4,mmm);
			 if(page!=0)
			  {
				outport(bxx,ModPtrAC->PSTSW );
				outportb(base+SET_EN_ADC ,0) ;
				outport(bxx,ModPtrAC->PSTSW & 0xfffe );
				outport(bxx,ModPtrAC->PSTSW | 0x0001 );
			  }
			 continue ;
			}
		 }

		if((inport(base+STATUS_READ) & 0x0010) !=0 )
		 {
		  outport(bxx,norm);
		  ModPtrAC->PSTSW = norm ;
		  errcode = LC0_OVERRUN ;
		  break ;
		 }

		if(ModPtrAC->SynEnable)
		 {
		  if(ModPtrAC->AsyncEnable==0)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 ModPtrAC->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		  if(IntBreak(&mes)==FALSE)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 }
	  }
	 break ;
	case 1 :
	 while(1)
	  {
		if((inportb(0xd0) & maska[mb]) != 0)
		 {

			 if(st==nst)
			  {
				outport(bxx,norm);
				ModPtrAC->PSTSW = norm ;
				break ;
			  }
			st++;

			 if((st & 0x01)==0)
			  {
				 kanDMAb=kanDMA2 ;
				 RejStronyb = RejStrony2 ;
				 LicznTransmisjib = LicznTransmisji2;
				 mp=mmm2 ;
				 mb = mmm ;
			  }
			 else
			  {
				 kanDMAb=kanDMA ;
				 RejStronyb = RejStrony ;
				 LicznTransmisjib = LicznTransmisji;
				 mp=mmm;
				 mb = mmm2 ;
			  }

			if(st!=nst)
			  {
				outportb(0xd4,kanDMAb) ;
				stb+=2;

				outportb(RejStronyb,stb);
				if(st==nst-1)
				 {
				  v1=v3;
				  v2=v4;
				 }
				outportb(0xd8,0xff);
				outportb(LicznTransmisjib,v1) ;
				outportb(LicznTransmisjib,v2);

				outportb(0xd4,mp);
			  }
			  continue ;
		 }

		if((inport(base+STATUS_READ) & 0x0010) !=0 )
		 {
		  outport(bxx,norm);
		  ModPtrAC->PSTSW = norm ;
		  errcode = LC0_OVERRUN ;
		  break ;
		 }

		if(ModPtrAC->SynEnable)
		 {
		  if(ModPtrAC->AsyncEnable==0)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 ModPtrAC->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		  if(IntBreak(&mes)==FALSE)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 }

		}

	 break ;
	case 2 :
	{
	 while(1)
	  {

		if((fDMA==TRUE)&&(strx==FALSE))
		 {

			outportb(0xd8,0x0);
			v5l=inportb(LicznTransmisji);
			v5h=inportb(LicznTransmisji);
			if((inportb(0xd0) & maska[mb]) != 0)
			 strx=TRUE ;
		 }

		if(!cycl)
		 {
			if(fDMA==TRUE)
			 {
			  if((inport(base+STATUS_READ) & 0x0002) !=0 )
				{
				 fDMA=FALSE ;
				 mb=mmm2;
				 continue;
				}
			 }
			else
			 {
				if((inportb(0xd0) & maska[mb]) != 0)
				 {
					if(st==nst)
					{
					 outport(bxx,norm);
					 ModPtrAC->PSTSW = norm ;
					 inportb(0xd0);
					 break ;
					}
				  continue ;
				 }
			 }
		 }

		  if((inport(base+STATUS_READ) & 0x0010) !=0 )
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 errcode = LC0_OVERRUN ;
			 break ;
			}


		if(ModPtrAC->SynEnable)
		 {
		  if(ModPtrAC->AsyncEnable==0)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 ModPtrAC->AsyncEnable=1;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		  if(IntBreak(&mes)==FALSE)
			{
			 outport(bxx,norm);
			 ModPtrAC->PSTSW = norm ;
			 errcode = LC0_BROKEN ;
			 break ;
			}
		 }
	  }
	 break ;
	}
  }

 ModPtrAC->ResetAC();
 if(cycl)
  {
	ModPtrAC->SynEnable = pb;
	outportb(0xd8,0);
	cl=inportb(LicznTransmisji);
	ch=inportb(LicznTransmisji);
	*ARBUF = (ch<<8) + cl ;
	*ARBUF = (signed)*lpret -1 - (signed)*ARBUF ;
  }

 outportb(0xd8,0xff);
 if(DMAMode==0)
  {
	v1=inportb(LicznTransmisji);
	v2=inportb(LicznTransmisji);
  }
 else
  {
	if(LicznTransmisjib==LicznTransmisji)
	 LicznTransmisjib = LicznTransmisji2;
	else
	 LicznTransmisjib =LicznTransmisji ;
	v1=inportb(LicznTransmisjib);
	v2=inportb(LicznTransmisjib);
  }
 x=(v2<<8) + v1 ;
 unsigned long int LP;
 switch(DMAMode)
  {
	 case		0 :
	 case		1 :if((nst==0) || (st==nst))
					 x = est -x ;
					else
					 if(st<nst)
						x = (unsigned int)65535 - x ;
					*ARMNUM = st*65536 + x ;
					break;
	 case	   2 :
					if(strx==FALSE)
					 LP = *lpret - (unsigned long int)((int)(((int)v5h<<8)+(int)v5l) +1) ;
					else
					 LP = *lpret ;
					if(cycl)
					 {
					  *ARMNUM = LP ;
					 }
					else
					 {
					  if(fDMA==TRUE)
						*ARMNUM =LP;
					  else
						{
						 *ARMNUM =*lpret ;
						 if(st==0)
						  {

							outportb(0xd8,0xff);
							v1=inportb(LicznTransmisji2);
							v2=inportb(LicznTransmisji2);
							x =(v2<<8) + v1 ;
							*ARMNUM += (unsigned long int)(est+1) -(x +1);

						  }
						 else
						  {
							*ARMNUM +=65536L - *lpret  ;
							st-=1;nst-=1;
							//dalej normalnie
							if((nst==0) || (st==nst))
							 x = est -x ;
							else
							 if(st<nst)
							  x = (unsigned int)65535 - x ;
							*ARMNUM += st*65536 + x ;
						  }
						}
					 }
					*lpret = LP;
					break;
  }

 return(errcode) ;
}


