
#include <windows.h>
#include <toolhelp.h>
#include <stdio.h>
/* adresy bazowe moduw */
#define	BASEA		0x1300
#define	BASEB		0x1220

#define  KEYBREAK1 VK_CANCEL

/* liczby poszczeglnych zasobw staych kart LC-015-1612 */
#define	AC_NUM  			1      /* ilo przetwornikw A/C */
#define  CTC_NUM			3      /* ilo kanaw CTC */
#define	DIN_NUM			2      /* ilo portw DigIn */
#define	DOUT_NUM			2      /* ilo portw DigOut */
#define	DBITS				8      /* ilo bitw portw cyfrowych  */
#define	AC_CHANNELS		16     /* ilo kanaw A/C */
#define	AC_BITS			12     /* 12 bitw A/C */
#define	CA_BITS			12     /* 12 bitw C/A */
#define	CA_CONV			1000   /* czas konwersji C/A */

/////////////////////////////////////////////////////////////////////////////
// definicje zwizane ze sprztem karty
/////////////////////////////////////////////////////////////////////////////
/* adresy offset poszczeglnych portw karty LC-011-1612 - patrz instrukcja
	obsugi */
/* rejestry 8-o bitowe*/
#define CTC_0			0
#define CTC_1  		4
#define CTC_2  		8
#define RAM_WRITE		12
#define ADC_ST_PR		13
#define DAC_ST_PR  	14
#define SET_EN_ADC	15
#define RAM_READ  	12

/* rejestry 16-o bitowe */
#define STATUS_WRITE  16
#define DIG_OUT_WRITE 18
#define SET_EN_DAC 	 20
#define DAC_1_WRITE 	 22
#define DAC_2_WRITE 	 24
#define STATUS_READ 	 16
#define DIG_IN_READ 	 18
#define ADC_READ 	 	 20

/* maski bitw rejestru STATUS_WRITE */
#define _RESET_IRQ   	 	 1
#define _ENABLE_IRQ  	 	 2
#define _ENABLE_DMA_ADC	 	 4
#define _ENABLE_SAMPLE_IN	 8
#define ENABLE_CTC_ADC		 16
#define ENABLE_CHG_DMA_ADC	 32
#define _ENABLE_PRETRIG_ADC 64
#define _ENABLE_DIF       	 128
#define  _DAC_SINGLE			 256
#define  _ENABLE_CTRL_IN	 512
#define	_ENABLE_DMA_DAC	 1024
#define  ENABLE_CTC_DAC		 2048
#define	_ENCHAN2				 4096
#define  _RESET_ADC			 16384
#define  _RESET_DAC			 32768

/* maski bitw rejestru STATUS_READ */
#define ADC_DATA_READY   	 1
#define IRQ_ADC_TRIG	   	 2
#define IRQ_ADC_SEQ			 4
#define IRQ_ADC_DMA		 	 8
#define IRQ_ADC_OVR			 16
#define IRQ_DAC_TRIG  	    32
#define IRQ_DAC_CTRL  	    64
#define IRQ_EXTERNAL  	    128

/* rzezcy nie uywane */
#define DMABUF				4096
#define LC0_FROM_DMA		0
#define LC0_TO_DMA		1

#define LC0_EXTMEM		0
#define LC0_PROG			1

struct DMA_transmit
{
  unsigned char Client		;
  unsigned char direction	;
  unsigned char module		;
  int huge *ProgBuf			;
  unsigned long DMAOffset	;
  unsigned long ClientOffset;
  unsigned long samples		 ;
};

////////////////////////////////////////////////////////////////////////////
// funkcja dokonujca transferu danych pomidzy wsplnym dla wszystkich
// moduw buforem pamici liniowej dla DMA a buforami uytkowymi (pam.rozszerzonej
//lub programowy) konkretnego moduu . Przeznaczenie do obsugi wewntrznych transferw
// w sekcjach trybu pracy blokowej DMA funkcji LC0_AnalogIn i LC0_AnalogOut
///////////////////////////////////////////////////////////////////////////////
char DMAToClientTransfer(DMA_transmit *param);

////////////////////////////////////////////////////////////////////////////////
// alokacja i zwolnienie pamici wewnetrznego bufora DMA
////////////////////////////////////////////////////////////////////////////////
void AllocDMABuffer()	;//alokuje bufor wewnetrzny DMA -> LibMain()
void FreeDMABuffer()		;//zwalnia DMA bufor            -> WEP();
////////////////////////////////////////////////////////////////////////////////
/* koniec rzeczy nie uywanych */

/* struktura z informacjami globalnymi o konfiguracji*/
struct global
 {
	unsigned char modules 						; /* ilo moduw z pliku INI*/
	char path[100]		 							; /* - */
	unsigned int inttime							; /* - */
	BOOL globalinit								; /* czy inicjacja globalna DLL OK*/
	char Error										; /* blad inicjacji globalnej */
	char DMAError									; /* blad inicjacji DMA */
	// parametry wewntrznego bufora DMA
	HGLOBAL	hglb									; /* - */
	void FAR *ptrbuf								; /* - */
	DWORD SegBase									; /* - */
	DWORD DMAAdress								; /* - */
	DWORD WinFlags									; /* flagi uruchomienia Windows */
 };

/* struktury z parametrami przetwarzania funkcji A/C i
	C/A */
struct ParAC
{
 BOOL single		 ; /* czy praca 1-o kanalowa */
 BOOL block			 ; /* czy praca blokowa */
 BOOL syn			 ; /* czy praca synchroniczna*/
 BOOL longbuf	  	 ; /* czy ilo prbek > 65536 */
 BOOL shard        ; /* czy sprztowy start bloku pomiarw */
 BOOL seqmem		 ; /* czy praca w trybie bezpor. programowania pam. sekwencji*/
 BOOL pretrig		 ; /* czy praca w trybie pretriggeringu */
 BOOL cycl			 ; /* czy praca w trybie cyklicznego pomiaru */
 unsigned char chan ;  /* numer kanau / liczba kanaw */
 unsigned long CTCLong ; /* 32biy slowo CTC jako czestotliwosc probkowania*/
 unsigned int CTCWord1,CTCWord2 ;/* 2 podzielniki CTC f prbkowania */
 lc0_start PStart	; /* parametry startu */
 lc0_stop  PStop	; /* parametry stopu */
 unsigned char PStSt ; /* typ warunku startu */
 unsigned int  Mode	; /* tryb pracy w sensie LC0_AMODE */
 BOOL DevBusy			; /* flaga zajtoci moduu */
 unsigned int PGACnt ; /* dugo pojedynczej konwersji A/C , odpowiedni CTC */
 unsigned long int lpret  ; /* ilo prbek bufora pretriggeringu dla trybu
										 pretriggering */
};

/* parametry pomiarowe funkcji C/A : analogia do A/C*/
struct ParCA
{
 BOOL single		 ;
 BOOL block			 ;
 BOOL syn			 ;
 BOOL longbuf		 ;
 BOOL shard			 ;
 unsigned long ll,CTCLong  ;  /* ll : ilo prbek do wyslania */
 unsigned int CTCWord1,CTCWord2 ;
 lc0_start PStart	;
 lc0_stop  PStop	;
 unsigned char PStSt ;
 unsigned int  Mode	;
 BOOL DevBusy			;
};

class  CModuleData
{
 public :
  CModuleData(unsigned int BaseAdress);//konstruktor
  ~CModuleData()							  ;//destruktor
  void Exit()								  ;//czyszczenie zmiennych
  int CheckApp()							  ;//sprawdzanie stanu modulu
  char CheckModule()						  ;//test obecnoci moduu
  void MessageBreak()					  ;//CTRL-BREAK funkcja
  void ResetAC()							  ;//reset moduu : cz A/C
  void ResetCA()							  ;//reset moduu : czc C/A
  void ClearCard()						  ;//zerowanie sprztu karty
  void ResetCTC()							  ;//-
  void CTCInitWrite();                 //zapis wartosci poczatkowych do CTC
  void NormCA();                       //procedura normalizacyjna funkcji lc0_analog_out
  void NormAC();							   //procedura normalizacyjna funkcji lc0_analog_out
  int  IsCTCProg[3]						  ;//tablica z flagami zaprogramowania poszcz.
													//kanalow CTC urzytkownika
  unsigned char RWCTCMode[3]			  ;//tablica z flagami trybow pracy poszczeglnych
													// kanaw CTC urzytkownika
  unsigned char RBCTCMode[3]			  ;//tablica z flagami Zaprogramowania w tryb
													// Read Back Mode poszcz. kanaw CTC user'a
  BOOL IsInit								  ;//czy modu zainicjowany
  BOOL IsLoaded							  ;//czy modu zaadowany
  char InitError							  ;//kod bdu przy ladowaniu moduu
  BOOL IsIRQProc							  ;//czy jest procedura obs IRQ
  int IsAsyncOpAC,IsAsyncOpCA			  ;//czy jest operacja asynchronicza
													// A/C lub C/A
  int AsyncEnable							  ;//zezwolenie na CTRL-BREAK asynchroniczny
  int SynEnable							  ;//zezw. na CTRL-BREAK synchroniczne
  void FAR (*BreakProc)(void)			  ;//procedura CTRL-BREAK user'a
  HTASK AppTask    		              ;//deskryptor programu
  TASKENTRY AppInfo						  ;//info o aplikacji AppTask
  HGLOBAL	hexmem						  ;// -
  int huge *ptrex							  ;// - parametry bufora pamieci ExtMem
  unsigned long ExSize					  ;// -
  char AllocExtMem()				  		  ;// alokacja ExtMem - pami rozszerzona
  void FreeExMem()				  		  ;// zwolnienie ExtMem
  lc0_analog_in  ACParam				  ;// parametry przetwarzania A/C
  lc0_analog_out CAParam				  ;// parametry przetwarzania C/A
  BOOL ACValid , CAValid				  ;// flagi waznoci parametrw
  ParAC PAC									  ;// przetworzone parametry A/C
  ParCA PCA									  ;// przetworzone parametry C/A
  unsigned int	BaseAdr					  ;// adres bazowy
  unsigned char ExMem					  ;// czy jest pamiec rozszerzona
  unsigned long int InExSize 			  ;//
  //////////////////////////////////////////////////////////////////////
  unsigned char mode						  ;// tryb pracy A/C
  unsigned char CLK						  ;// ~ parametr z konfiguracji
  unsigned char CA_channels			  ;// ~ parametr z konfiguracji
  char AC_V1							 	  ;// ~ parametr z konfiguracji
  char AC_V2							 	  ;// ~ parametr z konfiguracji
  unsigned char AC_DMA					  ;// ~ parametr z konfiguracji
  unsigned char AC_DMA2					  ;// ~ parametr z konfiguracji : numer kan. DMA
  unsigned int Tconv						  ;// ~ parametr z konfiguracji
  unsigned int STable[32]				  ;// tablica min. czasw konwersji A/C
  char CA1_V1							 	  ;// ~ parametr z konfiguracji
  char CA1_V2							 	  ;// ~ parametr z konfiguracji
  char CA2_V1	,CA2_V2				 	  ;// ~ parametr z konfiguracji
  unsigned char CA_DMA					  ;// ~ parametr z konfiguracji : numer kan. DMA
  unsigned int  CA_Table[2]			  ;// ~ parametr z konfiguracji
  unsigned int  IRQ						  ;// ~ parametr z konfiguracji : numer IRQ
  unsigned int PSTSW						  ;// rejestr STATUS_WRITE
  unsigned int PDIGW						  ;// rejestr DIG_OUT_WRITE
  unsigned char IsConvtable			  ;// czy podano tablice min. czasow konw. A/C
  unsigned char VPGA ;						//
  unsigned char PGA  ;                 // typ ukadu PGA
  unsigned char InType ;               // typ wej : symetryczne , niesymetryczne
  unsigned char ADType ;				   // typ przetwornika A/C w sensie kod U2 lub binarny
  char MemoryTest()  ;						// test pamici sekwencji moduu
  //zaprogramowanie pamici sekwencji moduu
  char ProgMem(BOOL single , unsigned char chan , unsigned char *ptr,BOOL block);
  //zerowanie , ustawianie na 0V napic na przetwornikach C/A
  void ClearDACs();
  void SetConvTime() ;//ustalenie czasu pojedynczej konwersji A/C w zal. od wzmocnienia
							 // i szybkoci preztwornika A/C
} ;

/* struktura do monitorowania stanu DMA A/C i C/A*/
struct WaitForEndParam
{
 unsigned char strona ;  // rejestr strony kana DMA 1
 unsigned char strona2;  // rejestr strony kana DMA 2
 unsigned int nst		 ;  // ilo stron
 unsigned int est		 ;  // ostatnia strona
 unsigned char modnum ;  // numer moduu
 unsigned char page   ;  // numer strony transmisji
 unsigned int st		 ;  //
 unsigned char kanDMA;   // numer kanau DMA 1
 unsigned char kanDMA2;  // numer kanau DMA 2
 unsigned char LicznTransmisji ;  //rejestr licznika transmisji kan. DMA 1
 unsigned char LicznTransmisji2 ; //rejestr licznika transmisji kan. DMA 2
 unsigned char RejStrony;  // rejestr strony kan. DMA 1
 unsigned char RejStrony2; // rejestr strony kan. DMA 2
 unsigned char v3;         // parametry pomocnicze
 unsigned char v4;         // ~  ~
 unsigned int base ;       // adres bazowy przetwornika A/C
 int cykl;                 // 1: tryb pracy cykliczny A/C
} ;

////////////////////////////////////////////////////////////////////////////
// prototypy funkcji globalnych
///////////////////////////////////////////////////////////////////////////
void ACMeasure(unsigned char mod);
FILE* SearchFile(char *) ;
char* FindLine(int,FILE * , char * , char * ,int) ;
char * FindParam(char * , char *) ;
int ReadIniFile(char *,unsigned long * ) ;
int ParamToInt(FILE * , int  ,int *);
int ParamToTab(FILE * , int ,int ,unsigned int *,int)  ;
int ParamToList(FILE *ini,int nr,int *number,char *strpar[],int intpar[]);
int ReadIniModule(char *  , unsigned char );
int ReadIniModuleAll(char *,unsigned long);
void LoadParameters(void);
char FAR PASCAL WaitForStart(unsigned char , unsigned char [],
						unsigned long  , char *,unsigned char,int) ;
char WaitForALevel( unsigned char [],char *,int);
BOOL IntBreak(MSG *);
void dividers(unsigned long , unsigned int *,unsigned int *);
char CheckModule(unsigned int);
unsigned char ProgDMA16(int kanal , int tryb , int cykl , int zapis , unsigned int il_s ,
 unsigned long int fadres);
void disableDMA16(int kanal);
char WaitForEndAC(int DMAMode ,
						unsigned char strona,
						unsigned char strona2,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned char page,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char kanDMA2,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char LicznTransmisji2,
						unsigned char RejStrony2,
						unsigned char v3,
						unsigned char v4,
						unsigned char v5,
						unsigned char v6,
						unsigned int base,
						BOOL shard,
						unsigned int norm ,
						BOOL cycl ,
						unsigned long int *lpret ,
						unsigned  int *ARBUF,
						unsigned long int *ARMNUM);
char WaitForEndCA(unsigned char strona,
						unsigned int nst	  ,
						unsigned int est	  ,
						unsigned int st,
						unsigned char kanDMA,
						unsigned char LicznTransmisji,
						unsigned char RejStrony,
						unsigned char v3,
						unsigned char v4,
						unsigned int base,
						int cykl,
						BOOL shard,
						unsigned int norm ,
						unsigned long int *NRMNUM);


